Date: Tue, 9 Jun 1998 09:40:23 +0200 (CEST)
From: Geert Uytterhoeven <Geert.Uytterhoeven@cs.kuleuven.ac.be>
To: Jes Sorensen <Jes.Sorensen@cern.ch>
cc: linux-m68k@lists.linux-m68k.org
Subject: Re: L68K: 2.1.105
In-Reply-To: <199806081554.RAA13947@valhall.cern.ch>
Sender: owner-linux-m68k@phil.uni-sb.de

On Mon, 8 Jun 1998, Jes Sorensen wrote:
> [1]: I won't even bother to write the story about the patches I missed.

  - Zorro patches

  - APUS patches (by Jesper)

  - Removed duplicate CONFIG_BLK_DEV_MAC_IDE from arch/m68k/config.in

  - Fix problem with CONFIG_HPDCA in drivers/char/m68kserial.c

Sound doesn't link due to soundcore_init().

diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/Documentation/Configure.help m68k/Documentation/Configure.help
--- jes-2.1.105/Documentation/Configure.help	Mon Jun  8 20:44:54 1998
+++ m68k/Documentation/Configure.help	Mon Jun  8 22:42:50 1998
@@ -8346,17 +8346,14 @@
   really know what you are doing, say N. Try Y only if you're
   quite adventurous.
 
-Amiga AutoConfig Identification
+Amiga Zorro (AutoConfig) bus support
 CONFIG_ZORRO
-  This enables support for automatic identification of Amiga expansion
-  cards that obey the AutoConfig(tm) specification.
-  Say Y if you want your expansion cards to be identified on bootup;
-  it will enlarge your kernel by about 10KB. The identification
-  information is also available through /proc/zorro (say Y to
-  "/proc filesystem support"!).
-
-  Note that even if you say N here, you can still use your expansion
-  cards. If in doubt, say Y.
+  Zorro is the name of the expansion bus used in Amiga systems. It
+  provides real Plug-and-Play through the AutoConfig(tm) protocol.
+  Say Y if you want to use your Zorro expansion cards, otherwise say N.
+  Note that expansion cards that do not plug in a Zorro connector (but
+  e.g. in the CPU socket) may still behave like Zorro boards.
+  If in doubt, say Y.
 
 Amiga OCS chipset support
 CONFIG_AMIFB_OCS
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/m68k/amiga/amiga_ksyms.c m68k/arch/m68k/amiga/amiga_ksyms.c
--- jes-2.1.105/arch/m68k/amiga/amiga_ksyms.c	Thu May 14 21:34:07 1998
+++ m68k/arch/m68k/amiga/amiga_ksyms.c	Sun Jun  7 21:27:45 1998
@@ -19,9 +19,3 @@
 EXPORT_SYMBOL(amiga_chip_size);
 EXPORT_SYMBOL(amiga_audio_period);
 EXPORT_SYMBOL(amiga_audio_min_period);
-
-EXPORT_SYMBOL(zorro_find);
-EXPORT_SYMBOL(zorro_get_board);
-EXPORT_SYMBOL(zorro_config_board);
-EXPORT_SYMBOL(zorro_unconfig_board);
-EXPORT_SYMBOL(zorro_unused_z2ram);
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/m68k/amiga/amiints.c m68k/arch/m68k/amiga/amiints.c
--- jes-2.1.105/arch/m68k/amiga/amiints.c	Sun Feb  8 23:14:43 1998
+++ m68k/arch/m68k/amiga/amiints.c	Mon Jun  1 10:51:29 1998
@@ -32,6 +32,12 @@
 #include <asm/traps.h>
 #include <asm/amigahw.h>
 #include <asm/amigaints.h>
+#ifdef CONFIG_APUS
+#include <asm/amigappc.h>
+/* Rename a few functions. */
+#define amiga_request_irq request_irq
+#define amiga_free_irq free_irq
+#endif
 
 extern int cia_request_irq(struct ciabase *base,int irq,
                            void (*handler)(int, void *, struct pt_regs *),
@@ -89,9 +95,16 @@
 	for (i = 0; i < AMI_IRQS; i++)
 		ami_ablecount[i] = 0;
 
-	/* turn off all interrupts and enable the master interrupt bit */
+	/* turn off all interrupts... */
 	custom.intena = 0x7fff;
 	custom.intreq = 0x7fff;
+
+#ifdef CONFIG_APUS
+	APUS_WRITE(APUS_REG_INT, REGINT_INTMASTER | REGINT_ENABLEIPL);
+	APUS_WRITE(APUS_IPL_EMU, IPLEMU_DISABLEINT);
+	APUS_WRITE(APUS_IPL_EMU, IPLEMU_SETRESET | IPLEMU_IPLMASK);
+#endif
+	/* ... and enable the master interrupt bit */
 	custom.intena = IF_SETCLR | IF_INTEN;
 
 	cia_init_IRQ(&ciaa_base);
@@ -353,8 +366,16 @@
 		server->count--;
 		return;
 	}
+#ifdef CONFIG_APUS
+	APUS_WRITE(APUS_IPL_EMU, IPLEMU_SETRESET | IPLEMU_DISABLEINT);
+	APUS_WRITE(APUS_IPL_EMU, IPLEMU_IPLMASK);
+	APUS_WRITE(APUS_IPL_EMU, (IPLEMU_SETRESET
+				  | (~(fp->mq) & IPLEMU_IPLMASK)));
+	APUS_WRITE(APUS_IPL_EMU, IPLEMU_DISABLEINT);
+#else
 	save_flags(flags);
 	restore_flags((flags & ~0x0700) | (fp->sr & 0x0700));
+#endif
 	/* if slow handlers exists, serve them now */
 	slow_nodes = node;
 	for (;;) {
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/m68k/amiga/config.c m68k/arch/m68k/amiga/config.c
--- jes-2.1.105/arch/m68k/amiga/config.c	Mon May  4 20:28:34 1998
+++ m68k/arch/m68k/amiga/config.c	Sun Jun  7 21:27:45 1998
@@ -31,6 +31,10 @@
 #include <asm/machdep.h>
 #include <linux/zorro.h>
 
+#ifdef CONFIG_APUS
+#include <asm/io.h>
+#endif
+
 unsigned long amiga_model;
 unsigned long amiga_eclock;
 unsigned long amiga_masterclock;
@@ -76,7 +80,6 @@
 #endif
 static void amiga_reset (void);
 static int amiga_wait_key (struct console *co);
-extern void zorro_init(void);
 extern void amiga_init_sound(void);
 static void amiga_savekmsg_init(void);
 static void amiga_mem_console_write(struct console *co, const char *b,
@@ -344,10 +347,12 @@
   mach_kbdrate         = amiga_kbdrate;
   mach_init_IRQ        = amiga_init_IRQ;
   mach_default_handler = &amiga_default_handler;
+#ifndef CONFIG_APUS
   mach_request_irq     = amiga_request_irq;
   mach_free_irq        = amiga_free_irq;
   enable_irq           = amiga_enable_irq;
   disable_irq          = amiga_disable_irq;
+#endif
   mach_get_model       = amiga_get_model;
   mach_get_hardware_list = amiga_get_hardware_list;
   mach_get_irq_list    = amiga_get_irq_list;
@@ -396,27 +401,6 @@
   /* ensure that the DMA master bit is set */
   custom.dmacon = DMAF_SETCLR | DMAF_MASTER;
 
-  /* don't use Z2 RAM as system memory on Z3 capable machines */
-  if (AMIGAHW_PRESENT(ZORRO3)) {
-    int i, j;
-    unsigned long z2mem = 0;
-    for (i = 0; i < m68k_num_memory; i++)
-      if (m68k_memory[i].addr < 16*1024*1024) {
-	if (i == 0) {
-	  /* don't cut off the branch we're sitting on */
-	  printk("Warning: kernel runs in Zorro II memory\n");
-	  continue;
-	}
-	z2mem += m68k_memory[i].size;
-	m68k_num_memory--;
-	for (j = i; j < m68k_num_memory; j++)
-	  m68k_memory[j] = m68k_memory[j+1];
-      }
-    if (z2mem)
-      printk("%ldK of Zorro II memory will not be used as system memory\n",
-	     z2mem>>10);
-  }
-
   /* initialize chipram allocator */
   amiga_chip_init ();
 
@@ -442,12 +426,8 @@
   if (AMIGAHW_PRESENT(MAGIC_REKICK))
 	  *(unsigned char *)ZTWO_VADDR(0xde0002) |= 0x80;
 
-  zorro_init();
 #ifdef CONFIG_ZORRO
-  /*
-   * Identify all known AutoConfig Expansion Devices
-   */
-  zorro_identify();
+  zorro_init();
 #endif
 }
 
@@ -713,6 +693,7 @@
 
 static void amiga_reset (void)
 {
+#ifdef __mc68000__
   unsigned long jmp_addr040 = VTOP(&&jmp_addr_label040);
   unsigned long jmp_addr = VTOP(&&jmp_addr_label);
 
@@ -770,9 +751,9 @@
      "1:\n\t"
      "reset\n\t"
      "jmp   %/a0@" : /* Just that gcc scans it for % escapes */ );
+#endif  
   
   for (;;);
-
 }
 
 
@@ -815,9 +796,17 @@
 
 static void amiga_serial_putc(char c)
 {
-    custom.serdat = (unsigned char)c | 0x100;
-    while (!(custom.serdatr & 0x2000))
-	;
+	custom.serdat = (unsigned char)c | 0x100;
+
+#ifdef CONFIG_APUS
+	/* I'm sure this should not be necessary since the address is
+	   marked non-cachable and coherent. Still, without it the
+	   serial output is not usable. -jskov */
+	eieio ();
+#endif
+
+	while (!(custom.serdatr & 0x2000))
+		;
 }
 
 void amiga_serial_console_write(struct console *co, const char *s,
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/m68k/config.in m68k/arch/m68k/config.in
--- jes-2.1.105/arch/m68k/config.in	Mon Jun  8 20:45:23 1998
+++ m68k/arch/m68k/config.in	Mon Jun  8 23:08:44 1998
@@ -79,7 +79,7 @@
 tristate 'Kernel support for MISC binaries' CONFIG_BINFMT_MISC
 
 if [ "$CONFIG_AMIGA" = "y" ]; then
-  bool 'Amiga AutoConfig Identification' CONFIG_ZORRO
+  bool 'Amiga Zorro (AutoConfig) bus support' CONFIG_ZORRO
 fi
 if [ "$CONFIG_ATARI" = "y" ]; then
   bool 'Support for ST-RAM as swap space' CONFIG_STRAM_SWAP
@@ -131,23 +131,24 @@
 
 if [ "$CONFIG_AMIGA" = "y" ]; then
   tristate 'A3000 WD33C93A support' CONFIG_A3000_SCSI
+  if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
+    bool 'A4000T SCSI support' CONFIG_A4000T_SCSI
+  fi
+fi
+if [ "$CONFIG_ZORRO" = "y" ]; then
   tristate 'A2091 WD33C93A support' CONFIG_A2091_SCSI
   tristate 'GVP Series II WD33C93A support' CONFIG_GVP11_SCSI
   bool 'CyberStorm SCSI support' CONFIG_CYBERSTORM_SCSI
-  bool 'CyberStorm SCSI Mk II support' CONFIG_CYBERSTORMII_SCSI
+  bool 'CyberStorm Mk II SCSI support' CONFIG_CYBERSTORMII_SCSI
   bool 'Blizzard 2060 SCSI support' CONFIG_BLZ2060_SCSI
   bool 'Blizzard 1230IV/1260 SCSI support' CONFIG_BLZ1230_SCSI
   bool 'Fastlane SCSI support' CONFIG_FASTLANE_SCSI
   if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
-    bool 'A4000T SCSI support' CONFIG_A4000T_SCSI
     bool 'A4091 SCSI support' CONFIG_A4091_SCSI
     bool 'WarpEngine SCSI support' CONFIG_WARPENGINE_SCSI
 #    bool 'Cyberstorm Mk III SCSI support' CONFIG_CYBERSTORMIII_SCSI
 #    bool 'GVP Turbo 040/060 SCSI support' CONFIG_GVP_TURBO_SCSI
   fi
-  if [ "$CONFIG_MAC" = "y" ]; then
-    bool '   Macintosh Quadra/Powerbook IDE interface support' CONFIG_BLK_DEV_MAC_IDE
-  fi
 fi
 if [ "$CONFIG_ATARI" = "y" ]; then
   dep_tristate 'Atari native SCSI support' CONFIG_ATARI_SCSI $CONFIG_SCSI
@@ -199,7 +200,7 @@
   comment 'CCP compressors for PPP are only built as modules.'
 fi
 tristate 'EQL (serial line load balancing) support' CONFIG_EQUALIZER
-if [ "$CONFIG_AMIGA" = "y" ]; then
+if [ "$CONFIG_ZORRO" = "y" ]; then
   tristate 'Ariadne support' CONFIG_ARIADNE
   tristate 'A2065 support' CONFIG_A2065
   tristate 'Hydra support' CONFIG_HYDRA
@@ -252,8 +253,10 @@
 fi
 
 tristate 'Parallel printer support' CONFIG_PRINTER
-if [ "$CONFIG_AMIGA" = "y" ]; then
+if [ "$CONFIG_ZORRO" = "y" ]; then
   dep_tristate 'Multiface Card III parallel support' CONFIG_MULTIFACE_III_LP $CONFIG_PRINTER
+fi
+if [ "$CONFIG_AMIGA" = "y" ]; then
   tristate 'Amiga mouse support' CONFIG_AMIGAMOUSE
 fi
 if [ "$CONFIG_ATARI" = "y" ]; then
@@ -275,11 +278,13 @@
 fi
 if [ "$CONFIG_AMIGA" = "y" ]; then
   tristate 'Amiga builtin serial support' CONFIG_AMIGA_BUILTIN_SERIAL
+  bool 'Hisoft Whippet PCMCIA serial support' CONFIG_WHIPPET
+fi
+if [ "$CONFIG_ZORRO" = "y" ]; then
   tristate 'GVP IO-Extender support' CONFIG_GVPIOEXT
   dep_tristate 'GVP IO-Extender parallel printer support' CONFIG_GVPIOEXT_LP $CONFIG_GVPIOEXT
   dep_tristate 'GVP IO-Extender PLIP support' CONFIG_GVPIOEXT_PLIP $CONFIG_GVPIOEXT
   tristate 'Multiface Card III serial support' CONFIG_MULTIFACE_III_TTY
-  bool 'Hisoft Whippet PCMCIA serial support' CONFIG_WHIPPET
 fi
 if [ "$CONFIG_MAC" = "y" ]; then
   bool 'Mac SCC serial support' CONFIG_MAC_SCC
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/m68k/kernel/ints.c m68k/arch/m68k/kernel/ints.c
--- jes-2.1.105/arch/m68k/kernel/ints.c	Mon Jun  8 20:45:26 1998
+++ m68k/arch/m68k/kernel/ints.c	Mon Jun  8 22:43:56 1998
@@ -38,8 +38,20 @@
 #include <asm/page.h>
 #include <asm/machdep.h>
 
+#ifdef CONFIG_APUS
+/* Rename a few functions to avoid conflicts. */
+#define request_irq nop_request_irq
+#define free_irq nop_free_irq
+#define enable_irq nop_enable_irq
+#define disable_irq nop_disable_irq
+#define probe_irq_on nop_probe_irq_on
+#define probe_irq_off nop_probe_irq_off
+#define init_IRQ apus_init_IRQ
+#endif
+
 /* table for system interrupt handlers */
-static irq_handler_t irq_list[SYS_IRQS];
+/* Cannot be static. Also accessed by ppc code. -jskov */
+irq_handler_t irq_list[SYS_IRQS];
 
 static const char *default_names[SYS_IRQS] = {
 	"spurious int", "int1 handler", "int2 handler", "int3 handler",
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/m68k/kernel/kgdb.c m68k/arch/m68k/kernel/kgdb.c
--- jes-2.1.105/arch/m68k/kernel/kgdb.c	Sun Feb  8 22:37:50 1998
+++ m68k/arch/m68k/kernel/kgdb.c	Mon Jun  1 10:51:29 1998
@@ -236,8 +236,8 @@
 static unsigned char atari_scc_intr( void );
 #endif
 #ifdef CONFIG_AMIGA
-static int amiga_ser_out( unsigned char c );
-static unsigned char amiga_ser_in( void );
+extern int amiga_ser_out( unsigned char c );
+extern unsigned char amiga_ser_in( void );
 #endif
 
 /************************* End of Prototypes **************************/
@@ -1192,35 +1192,3 @@
 }
 
 #endif
-
-
-/* -------------------- Amiga serial I/O -------------------- */
-
-#ifdef CONFIG_AMIGA
-
-static int amiga_ser_out( unsigned char c )
-
-{
-	custom.serdat = c | 0x100;
-	while (!(custom.serdatr & 0x2000))
-		barrier();
-	return( 1 );
-}
-
-
-static unsigned char amiga_ser_in( void )
-
-{
-	unsigned char c;
-	
-	/* XXX: is that ok?? derived from amiga_ser.c... */
-	while( !(custom.intreqr & IF_RBF) )
-		barrier();
-	c = custom.serdatr;
-	/* clear the interrupt, so that another character can be read */
-	custom.intreq = IF_RBF;
-	return( 0 );
-}
-
-#endif
-
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/m68k/kernel/setup.c m68k/arch/m68k/kernel/setup.c
--- jes-2.1.105/arch/m68k/kernel/setup.c	Mon Jun  8 20:45:27 1998
+++ m68k/arch/m68k/kernel/setup.c	Mon Jun  8 22:43:57 1998
@@ -30,6 +30,13 @@
 #ifdef CONFIG_ATARI
 #include <asm/atarihw.h>
 #endif
+#ifdef CONFIG_APUS
+#include <asm/mmu.h>
+/* Rename a few functions. */
+#define setup_arch apus_setup_arch
+#define get_cpuinfo apus_get_cpuinfo
+#define check_bugs nop_check_bugs
+#endif
 
 #ifdef CONFIG_BLK_DEV_INITRD
 #include <linux/blk.h>
@@ -49,7 +56,7 @@
 int m68k_num_memory = 0;
 struct mem_info m68k_memory[NUM_MEMINFO];
 
-static struct mem_info m68k_ramdisk = { 0, 0 };
+struct mem_info m68k_ramdisk = { 0, 0 };
 
 static char m68k_command_line[CL_SIZE];
 char saved_command_line[CL_SIZE];
@@ -108,7 +115,7 @@
 #define MASK_256K 0xfffc0000
 
 
-__initfunc(static void m68k_parse_bootinfo(const struct bi_record *record))
+__initfunc(void m68k_parse_bootinfo(const struct bi_record *record))
 {
     while (record->tag != BI_LAST) {
 	int unknown = 0;
@@ -164,6 +171,7 @@
 	int i;
 	char *p, *q;
 
+#ifdef __mc68000__
 	/* The bootinfo is located right after the kernel bss */
 	m68k_parse_bootinfo((const struct bi_record *)&_end);
 
@@ -179,11 +187,14 @@
 		volatile int zero = 0;
 		asm __volatile__ ("frestore %0" : : "m" (zero));
 	}
+#endif
 
+#ifndef CONFIG_APUS
 	init_task.mm->start_code = PAGE_OFFSET;
 	init_task.mm->end_code = (unsigned long) &_etext;
 	init_task.mm->end_data = (unsigned long) &_edata;
 	init_task.mm->brk = (unsigned long) &_end;
+#endif
 
 	*cmdline_p = m68k_command_line;
 	memcpy(saved_command_line, *cmdline_p, CL_SIZE);
@@ -273,10 +284,12 @@
 	}
 #endif
 
+#ifndef CONFIG_APUS
 	*memory_start_p = availmem;
 	*memory_end_p = 0;
 	for (i = 0; i < m68k_num_memory; i++)
 		*memory_end_p += m68k_memory[i].size & MASK_256K;
+#endif
 }
 
 int get_cpuinfo(char * buffer)
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/ppc/amiga/Makefile m68k/arch/ppc/amiga/Makefile
--- jes-2.1.105/arch/ppc/amiga/Makefile	Thu Jan  1 01:00:00 1970
+++ m68k/arch/ppc/amiga/Makefile	Sun May 24 21:46:24 1998
@@ -0,0 +1,15 @@
+#
+# Makefile for Linux arch/m68k/amiga source directory
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definitions are now in the main makefile...
+
+O_TARGET := amiga.o
+O_OBJS   := config.o amiints.o cia.o setup.o time.o \
+            amisound.o chipram.o zorro.o ints.o
+OX_OBJS  := amiga_ksyms.o
+
+include $(TOPDIR)/Rules.make
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/ppc/amiga/amiga_ksyms.c m68k/arch/ppc/amiga/amiga_ksyms.c
--- jes-2.1.105/arch/ppc/amiga/amiga_ksyms.c	Thu Jan  1 01:00:00 1970
+++ m68k/arch/ppc/amiga/amiga_ksyms.c	Sun May 24 21:46:24 1998
@@ -0,0 +1 @@
+#include "../../m68k/amiga/amiga_ksyms.c"
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/ppc/amiga/amiints.c m68k/arch/ppc/amiga/amiints.c
--- jes-2.1.105/arch/ppc/amiga/amiints.c	Thu Jan  1 01:00:00 1970
+++ m68k/arch/ppc/amiga/amiints.c	Sun May 24 21:46:24 1998
@@ -0,0 +1 @@
+#include "../../m68k/amiga/amiints.c"
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/ppc/amiga/amisound.c m68k/arch/ppc/amiga/amisound.c
--- jes-2.1.105/arch/ppc/amiga/amisound.c	Thu Jan  1 01:00:00 1970
+++ m68k/arch/ppc/amiga/amisound.c	Sun May 24 21:46:25 1998
@@ -0,0 +1 @@
+#include "../../m68k/amiga/amisound.c"
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/ppc/amiga/chipram.c m68k/arch/ppc/amiga/chipram.c
--- jes-2.1.105/arch/ppc/amiga/chipram.c	Thu Jan  1 01:00:00 1970
+++ m68k/arch/ppc/amiga/chipram.c	Sun May 24 21:46:25 1998
@@ -0,0 +1 @@
+#include "../../m68k/amiga/chipram.c"
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/ppc/amiga/cia.c m68k/arch/ppc/amiga/cia.c
--- jes-2.1.105/arch/ppc/amiga/cia.c	Thu Jan  1 01:00:00 1970
+++ m68k/arch/ppc/amiga/cia.c	Sun May 24 21:46:25 1998
@@ -0,0 +1 @@
+#include "../../m68k/amiga/cia.c"
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/ppc/amiga/config.c m68k/arch/ppc/amiga/config.c
--- jes-2.1.105/arch/ppc/amiga/config.c	Thu Jan  1 01:00:00 1970
+++ m68k/arch/ppc/amiga/config.c	Sun May 24 21:46:28 1998
@@ -0,0 +1 @@
+#include "../../m68k/amiga/config.c"
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/ppc/amiga/ints.c m68k/arch/ppc/amiga/ints.c
--- jes-2.1.105/arch/ppc/amiga/ints.c	Thu Jan  1 01:00:00 1970
+++ m68k/arch/ppc/amiga/ints.c	Sun May 24 21:46:28 1998
@@ -0,0 +1 @@
+#include "../../m68k/kernel/ints.c"
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/ppc/amiga/setup.c m68k/arch/ppc/amiga/setup.c
--- jes-2.1.105/arch/ppc/amiga/setup.c	Thu Jan  1 01:00:00 1970
+++ m68k/arch/ppc/amiga/setup.c	Sun May 24 21:46:28 1998
@@ -0,0 +1,200 @@
+#include "../../m68k/kernel/setup.c"
+
+extern unsigned long amiga_model;
+extern unsigned decrementer_count;	/* count value for 1e6/HZ microseconds */
+extern unsigned count_period_num;	/* 1 decrementer count equals */
+extern unsigned count_period_den;	/* count_period_num / count_period_den us */
+
+#include <asm/amigappc.h>
+
+void apus_calibrate_decr(void)
+{
+	int freq, divisor;
+	unsigned char c = *(unsigned char*)ZTWO_VADDR(0xf00011);
+
+	switch (c)
+	{
+	case 'A':
+	case 'B':
+		if (amiga_model == AMI_1200 || amiga_model == AMI_2000){
+			freq = 1;
+		} else {
+			freq = 0;
+		}
+		break;
+	case 'C':
+		if (amiga_model == AMI_1200 || amiga_model == AMI_2000){
+			freq = 0;
+		} else {
+			freq = 1;
+		}
+		break;
+	case 'D':
+		freq = 1;
+		break;
+	default:
+		freq = 0;
+		printk (" *Unknown CPU speed ID ('%c')* ", c);
+		break;
+	}
+
+	{
+		int speed;
+		switch (freq)
+		{
+		case 0:
+			freq = 15000000;
+			speed = 60;
+			
+			/* Use status of left mouse button to select
+			   RAM speed. */
+			if (!(ciaa.pra & 0x40))
+			{
+				APUS_WRITE (APUS_REG_WAITSTATE, 
+					    REGWAITSTATE_SETRESET
+					    |REGWAITSTATE_PPCR
+					    |REGWAITSTATE_PPCW);
+				printk (" [RAM R/W waitstate removed. "
+					"(expecting 60ns RAM).] ");
+			}
+			break;
+		case 1:
+			freq = 16500000;
+			speed = 66;
+			break;
+		}
+		printk ("PowerUp Bus Speed: %dMHz\n", speed);
+	}
+
+	freq *= 60;	/* try to make freq/1e6 an integer */
+        divisor = 60;
+        printk("time_init: decrementer frequency = %d/%d\n", freq, divisor);
+        decrementer_count = freq / HZ / divisor;
+        count_period_num = divisor;
+        count_period_den = freq / 1000000;
+}
+
+int mm_end_of_chunk (unsigned long addr, int len)
+{
+	if (m68k_memory[0].addr + m68k_memory[0].size == addr + len)
+		return 1;
+	return 0;
+}
+
+extern void
+map_page(struct task_struct *tsk, unsigned long va,
+	 unsigned long pa, int flags);
+
+#define KMAP_MAX 8
+static unsigned long kmap_chunks[KMAP_MAX*3];
+static int kmap_chunk_count = 0;
+
+/* Based on arch/ppc/mm/init.c:ioremap() which maps the address range
+   to the same virtual address as the physical address - which may
+   cause problems since Z3 IO space is not the same as PCI/ISA.
+   This should be rewritten to something more like the m68k version. */
+unsigned long kernel_map (unsigned long phys_addr, unsigned long size,
+			  int cacheflag, unsigned long *memavailp)
+{
+	unsigned long v_ret, end;
+	/* Remap to 0x90000000. Related comment in ppc/mm/init.c. */
+	static unsigned long virt = 0x90000000;
+	v_ret = virt;
+
+	if (kmap_chunk_count == KMAP_MAX*3)
+		panic ("kernel_map: Can only map %d chunks.\n",
+		       KMAP_MAX);
+
+	kmap_chunks[kmap_chunk_count++] = phys_addr;
+	kmap_chunks[kmap_chunk_count++] = size;
+	kmap_chunks[kmap_chunk_count++] = v_ret;
+
+	for (end = phys_addr + size ; phys_addr < end; 
+	     phys_addr += PAGE_SIZE, virt += PAGE_SIZE) {
+		map_page(&init_task, virt, phys_addr,
+			 pgprot_val(PAGE_KERNEL_CI) | _PAGE_GUARDED);
+	}
+	return v_ret;
+}
+		
+unsigned long mm_ptov (unsigned long paddr)
+{
+	unsigned long ret;
+	if (paddr < 16*1024*1024)
+		ret = ZTWO_VADDR(paddr);
+	else {
+		int i;
+
+		for (i = 0; i < kmap_chunk_count;){
+			unsigned long virt = kmap_chunks[i++];
+			unsigned long size = kmap_chunks[i++];
+			unsigned long phys = kmap_chunks[i++];
+			if (paddr >= phys
+			    && paddr < (phys + size)){
+				ret = virt + paddr - phys;
+				goto exit;
+			}
+		}
+		
+		ret = (unsigned long) __va(paddr);
+	}
+exit:
+#ifdef DEBUGPV
+	printk ("PTOV(%lx)=%lx\n", paddr, ret);
+#endif
+	return ret;
+}
+
+#define L1_CACHE_BYTES 32
+#define MAX_CACHE_SIZE 8192
+
+void cache_push(__u32 addr, int length)
+{
+	addr = mm_ptov(addr);
+
+	if (MAX_CACHE_SIZE < length)
+		length = MAX_CACHE_SIZE;
+
+	while(length > 0){
+		__asm ("dcbf 0,%0\n\t"
+		       : : "r" (addr));
+		addr += L1_CACHE_BYTES;
+		length -= L1_CACHE_BYTES;
+	}
+	/* Also flush trailing block */
+	__asm ("dcbf 0,%0\n\t"
+	       "sync \n\t"
+	       : : "r" (addr));
+}
+void cache_clear(__u32 addr, int length)
+{
+	if (MAX_CACHE_SIZE < length)
+		length = MAX_CACHE_SIZE;
+
+	addr = mm_ptov(addr);
+
+	__asm ("dcbf 0,%0\n\t"
+	       "sync \n\t"
+	       "icbi 0,%0 \n\t"
+	       "isync \n\t"
+	       : : "r" (addr));
+	
+	addr += L1_CACHE_BYTES;
+	length -= L1_CACHE_BYTES;
+
+	while(length > 0){
+		__asm ("dcbf 0,%0\n\t"
+		       "sync \n\t"
+		       "icbi 0,%0 \n\t"
+		       "isync \n\t"
+		       : : "r" (addr));
+		addr += L1_CACHE_BYTES;
+		length -= L1_CACHE_BYTES;
+	}
+
+	__asm ("dcbf 0,%0\n\t"
+	       "sync \n\t"
+	       "icbi 0,%0 \n\t"
+	       "isync \n\t"
+	       : : "r" (addr));
+}
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/arch/ppc/amiga/time.c m68k/arch/ppc/amiga/time.c
--- jes-2.1.105/arch/ppc/amiga/time.c	Thu Jan  1 01:00:00 1970
+++ m68k/arch/ppc/amiga/time.c	Sun May 24 21:46:28 1998
@@ -0,0 +1,71 @@
+#include <linux/config.h> /* CONFIG_HEARTBEAT */
+#include <linux/errno.h>
+#include <linux/sched.h>
+#include <linux/kernel.h>
+#include <linux/param.h>
+#include <linux/string.h>
+#include <linux/mm.h>
+
+#include <asm/machdep.h>
+#include <asm/io.h>
+
+#include <linux/timex.h>
+
+static inline unsigned long mktime(unsigned int year, unsigned int mon,
+	unsigned int day, unsigned int hour,
+	unsigned int min, unsigned int sec);
+
+unsigned long apus_get_rtc_time(void)
+{
+	unsigned int year, mon, day, hour, min, sec;
+
+	extern void arch_gettod(int *year, int *mon, int *day, int *hour,
+				int *min, int *sec);
+
+	arch_gettod (&year, &mon, &day, &hour, &min, &sec);
+
+	if ((year += 1900) < 1970)
+		year += 100;
+
+	return mktime(year, mon, day, hour, min, sec);
+}
+
+int apus_set_rtc_time(unsigned long nowtime)
+{
+  if (mach_set_clock_mmss)
+    return mach_set_clock_mmss (nowtime);
+  return -1;
+}
+
+/* Converts Gregorian date to seconds since 1970-01-01 00:00:00.
+ * Assumes input in normal date format, i.e. 1980-12-31 23:59:59
+ * => year=1980, mon=12, day=31, hour=23, min=59, sec=59.
+ *
+ * [For the Julian calendar (which was used in Russia before 1917,
+ * Britain & colonies before 1752, anywhere else before 1582,
+ * and is still in use by some communities) leave out the
+ * -year/100+year/400 terms, and add 10.]
+ *
+ * This algorithm was first published by Gauss (I think).
+ *
+ * WARNING: this function will overflow on 2106-02-07 06:28:16 on
+ * machines were long is 32-bit! (However, as time_t is signed, we
+ * will already get problems at other places on 2038-01-19 03:14:08)
+ */
+static inline unsigned long mktime(unsigned int year, unsigned int mon,
+	unsigned int day, unsigned int hour,
+	unsigned int min, unsigned int sec)
+{
+	if (0 >= (int) (mon -= 2)) {	/* 1..12 -> 11,12,1..10 */
+		mon += 12;	/* Puts Feb last since it has leap day */
+		year -= 1;
+	}
+	return (((
+	    (unsigned long)(year/4 - year/100 + year/400 + 367*mon/12 + day) +
+	      year*365 - 719499
+	    )*24 + hour /* now have hours */
+	   )*60 + min /* now have minutes */
+	  )*60 + sec; /* finally seconds */
+}
+
+
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/block/Config.in m68k/drivers/block/Config.in
--- jes-2.1.105/drivers/block/Config.in	Mon Jun  8 20:45:34 1998
+++ m68k/drivers/block/Config.in	Mon Jun  8 23:08:26 1998
@@ -32,10 +32,12 @@
     if [ "$CONFIG_AMIGA" = "y" ]; then
       bool '   Amiga Gayle IDE interface support' CONFIG_BLK_DEV_GAYLE
       if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
-	bool '   Buddha/Catweasel IDE interface support' CONFIG_BLK_DEV_BUDDHA
 	bool '   Amiga IDE Doubler support' CONFIG_BLK_DEV_IDEDOUBLER $CONFIG_BLK_DEV_GAYLE
       fi
     fi
+    if [ "$CONFIG_ZORRO" = "y" -a "$CONFIG_EXPERIMENTAL" = "y" ]; then
+      bool '   Buddha/Catweasel IDE interface support' CONFIG_BLK_DEV_BUDDHA
+    fi
     if [ "$CONFIG_ATARI" = "y" ]; then
       bool '   Falcon IDE interface support' CONFIG_BLK_DEV_FALCON_IDE
     fi
@@ -81,7 +83,7 @@
 if [ "$CONFIG_MCA" = "y" ]; then
   bool 'PS/2 ESDI harddisk support' CONFIG_BLK_DEV_PS2
 fi
-if [ "$CONFIG_AMIGA" = "y" ]; then
+if [ "$CONFIG_ZORRO" = "y" ]; then
   tristate 'Amiga Zorro II ramdisk support' CONFIG_AMIGA_Z2RAM
 fi
 if [ "$CONFIG_ATARI" = "y" ]; then
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/char/amiga_ser.c m68k/drivers/char/amiga_ser.c
--- jes-2.1.105/drivers/char/amiga_ser.c	Sun Feb  8 22:33:22 1998
+++ m68k/drivers/char/amiga_ser.c	Mon Jun  1 10:51:30 1998
@@ -339,13 +339,10 @@
     else
 	info->flags |= ASYNC_CHECK_CD;
 
-    if (baud & CBAUDEX) {
-	    baud &= ~CBAUDEX;
-	    if (baud < 1 || baud > 4)
-		    info->tty->termios->c_cflag &= ~CBAUDEX;
-	    else
-		    baud += 15;
-    }
+    if (baud & CBAUDEX)
+	baud = baud - (B57600 - B38400 - 1);
+
+
     if (baud == 15) {
 	    switch (aflags) {
 	    case ASYNC_SPD_HI:
@@ -370,7 +367,7 @@
 	if (baud > 16) baud = 16;
 	realbaud = baud_table[baud];
 	if (realbaud)
-	    div = (amiga_colorclock+realbaud/2)/realbaud-1;
+	    div = (amiga_colorclock+realbaud/2)/realbaud;
     }
 
     if (div) {
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/char/m68kserial.c m68k/drivers/char/m68kserial.c
--- jes-2.1.105/drivers/char/m68kserial.c	Mon Jun  8 20:45:52 1998
+++ m68k/drivers/char/m68kserial.c	Mon Jun  8 23:32:30 1998
@@ -166,7 +166,7 @@
 	"unknown", "8250", "16450", "16550", "16550A"
 };
 #define PORT_MAX (sizeof(serialtypes)/sizeof(*serialtypes))
-#ifdef __mc68000__
+#if defined(__mc68000__) || defined(CONFIG_APUS)
 static char *serialtypes68k[] = {
 	"SCC w/o DMA", "SCC w/ DMA",
 	"MFP", "MFP w/o ctrl lines",
@@ -196,7 +196,7 @@
 	if (!info->port) continue;
 	if (info->type >= 0 && info->type < PORT_MAX)
 	    name = serialtypes[info->type];
-#ifdef __mc68000__
+#if defined(__mc68000__) || defined(CONFIG_APUS)
 	else if (info->type >= 100 && info->type < 100 + M68K_PORT_MAX)
 	    name = serialtypes68k[info->type - 100];
 #endif
@@ -1531,7 +1531,7 @@
 
 	save_flags(flags);
 	cli();
-#ifndef __mc68000__
+#if !defined(__mc68000__) && !defined(CONFIG_APUS)
 	for (i = 0; i < NR_PORTS; i++) {
 		if (rs_table[i].port == req->port)
 			break;
@@ -1566,7 +1566,7 @@
 		       "device already open\n", i, req->port, req->irq);
 		return -EBUSY;
 	}
-#ifndef __mc68000__
+#if !defined(__mc68000__) && !defined(CONFIG_APUS)
 	info->irq = req->irq;
 	info->port = req->port;
 	autoconfig(info);
@@ -1584,7 +1584,7 @@
 #endif
 	if (info->type >= 0 && info->type < PORT_MAX)
 	    printk( "%s\n", serialtypes[info->type] );
-#ifdef __mc68000__
+#if defined(__mc68000__) || defined(CONFIG_APUS)
 	else if (info->type >= 100 && info->type < 100 + M68K_PORT_MAX)
 	    printk( "%s\n", serialtypes68k[info->type - 100] );
 #endif
@@ -1604,7 +1604,7 @@
 	if (info->tty)
 		tty_hangup(info->tty);
 	info->type = PORT_UNKNOWN;
-#ifdef __mc68000__
+#if defined(__mc68000__) || defined(CONFIG_APUS)
 	info->port = 0;
 #endif
 	printk(KERN_INFO "tty%02d unloaded\n", info->line);
@@ -1808,12 +1808,14 @@
 	 * because it's going to go away soon.
 	 * 	-- Peter Maydell <pmaydell@chiark.greenend.org.uk>
 	 */
-	if (MACH_IS_HP300 && CONFIG_HPDCA) {
+#ifdef CONFIG_HPDCA
+	if (MACH_IS_HP300) {
 		if (hpdca_init_serial_console(B9600|CS8)) {
 			sercons.write = hpdca_serial_console_write;
 			sercons.wait_key = hpdca_serial_console_wait_key;
 		}
 	}
+#endif
 	register_console(&sercons);
 	return kmem_start;
 }
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/scsi/fastlane.c m68k/drivers/scsi/fastlane.c
--- jes-2.1.105/drivers/scsi/fastlane.c	Sun Feb  8 22:34:27 1998
+++ m68k/drivers/scsi/fastlane.c	Mon Jun  1 10:51:30 1998
@@ -289,7 +289,9 @@
 		(struct fastlane_dma_registers *) (esp->dregs);
 
 	dregs->ctrl_reg = ctrl_data & ~(FASTLANE_DMA_EDI|FASTLANE_DMA_ESI);
+#ifdef __mc68000__
 	nop();
+#endif
 	dregs->ctrl_reg = ctrl_data;
 }
 
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/video/Config.in m68k/drivers/video/Config.in
--- jes-2.1.105/drivers/video/Config.in	Mon Jun  8 20:46:52 1998
+++ m68k/drivers/video/Config.in	Mon Jun  8 22:49:12 1998
@@ -20,6 +20,8 @@
       bool 'Amiga ECS chipset support' CONFIG_FB_AMIGA_ECS
       bool 'Amiga AGA chipset support' CONFIG_FB_AMIGA_AGA
     fi
+  fi
+  if [ "$CONFIG_ZORRO" = "y" ]; then
     tristate 'Amiga CyberVision support' CONFIG_FB_CYBER
     if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
       bool 'Amiga CyberVision3D support (experimental)' CONFIG_FB_VIRGE
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/video/amifb.c m68k/drivers/video/amifb.c
--- jes-2.1.105/drivers/video/amifb.c	Thu May 14 21:34:48 1998
+++ m68k/drivers/video/amifb.c	Mon Jun  1 10:51:30 1998
@@ -579,8 +579,14 @@
 #define modx(x,v)	((v) & ((x)-1))
 
 /* if x1 is not a constant, this macro won't make real sense :-) */
+#ifdef __mc68000__
 #define DIVUL(x1, x2) ({int res; asm("divul %1,%2,%3": "=d" (res): \
 	"d" (x2), "d" ((long)((x1)/0x100000000ULL)), "0" ((long)(x1))); res;})
+#else
+/* We know a bit about the numbers, so we can do it this way */
+#define DIVUL(x1, x2) ((((long)((unsigned long long)x1 >> 8) / x2) << 8) + \
+	((((long)((unsigned long long)x1 >> 8) % x2) << 8) / x2))
+#endif
 
 #define min(a, b)	((a) < (b) ? (a) : (b))
 #define max(a, b)	((a) > (b) ? (a) : (b))
@@ -1803,9 +1809,13 @@
 	 * Calculate the Pixel Clock Values for this Machine
 	 */
 
-	pixclock[TAG_SHRES] = DIVUL(25E9, amiga_eclock);	/* SHRES:  35 ns / 28 MHz */
-	pixclock[TAG_HIRES] = DIVUL(50E9, amiga_eclock);	/* HIRES:  70 ns / 14 MHz */
-	pixclock[TAG_LORES] = DIVUL(100E9, amiga_eclock); 	/* LORES: 140 ns /  7 MHz */
+	{
+	u_long tmp = DIVUL(200E9, amiga_eclock);
+
+	pixclock[TAG_SHRES] = (tmp + 4) / 8;	/* SHRES:  35 ns / 28 MHz */
+	pixclock[TAG_HIRES] = (tmp + 2) / 4;	/* HIRES:  70 ns / 14 MHz */
+	pixclock[TAG_LORES] = (tmp + 1) / 2;	/* LORES: 140 ns /  7 MHz */
+	}
 
 	/*
 	 * Replace the Tag Values with the Real Pixel Clock Values
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/video/atyfb.c m68k/drivers/video/atyfb.c
--- jes-2.1.105/drivers/video/atyfb.c	Mon Jun  8 20:46:53 1998
+++ m68k/drivers/video/atyfb.c	Mon Jun  8 23:15:33 1998
@@ -1654,12 +1654,7 @@
 	    default:
 		info->total_vram = 0x80000;
 	}
-#ifdef CONFIG_ATARI
-    /*
-     * this is definately the wrong way to set this, maybe this depends
-     * on the card being ISA - but using the size to determine this and
-     * only on the Atari is bollocks.
-     */
+#ifdef CONFIG_ATARI	/* this is definately not the wrong way to set this */
     if ((info->total_vram == 0x400000) || (info->total_vram == 0x800000)) {
 	/* protect GUI-regs if complete Aperture is VRAM */
 	info->total_vram -= 0x00001000;
@@ -2214,6 +2209,7 @@
 		 (struct fb_info_aty *)p->fb_info);
 }
 
+#ifdef CONFIG_FBCON_CFB8
 static void fbcon_aty8_putc(struct vc_data *conp, struct display *p, int c,
 			    int yy, int xx)
 {
@@ -2228,6 +2224,13 @@
     fbcon_cfb8_putcs(conp, p, s, count, yy, xx);
 }
 
+static struct display_switch fbcon_aty8 = {
+    fbcon_cfb8_setup, fbcon_aty_bmove, fbcon_aty_clear, fbcon_aty8_putc,
+    fbcon_aty8_putcs, fbcon_cfb8_revc, NULL
+};
+#endif
+
+#ifdef CONFIG_FBCON_CFB16
 static void fbcon_aty16_putc(struct vc_data *conp, struct display *p, int c,
 			     int yy, int xx)
 {
@@ -2242,6 +2245,13 @@
     fbcon_cfb16_putcs(conp, p, s, count, yy, xx);
 }
 
+static struct display_switch fbcon_aty16 = {
+    fbcon_cfb16_setup, fbcon_aty_bmove, fbcon_aty_clear, fbcon_aty16_putc,
+    fbcon_aty16_putcs, fbcon_cfb16_revc, NULL
+};
+#endif
+
+#ifdef CONFIG_FBCON_CFB32
 static void fbcon_aty32_putc(struct vc_data *conp, struct display *p, int c,
 			     int yy, int xx)
 {
@@ -2256,20 +2266,11 @@
     fbcon_cfb32_putcs(conp, p, s, count, yy, xx);
 }
 
-static struct display_switch fbcon_aty8 = {
-    fbcon_cfb8_setup, fbcon_aty_bmove, fbcon_aty_clear, fbcon_aty8_putc,
-    fbcon_aty8_putcs, fbcon_cfb8_revc, NULL
-};
-
-static struct display_switch fbcon_aty16 = {
-    fbcon_cfb16_setup, fbcon_aty_bmove, fbcon_aty_clear, fbcon_aty16_putc,
-    fbcon_aty16_putcs, fbcon_cfb16_revc, NULL
-};
-
 static struct display_switch fbcon_aty32 = {
     fbcon_cfb32_setup, fbcon_aty_bmove, fbcon_aty_clear, fbcon_aty32_putc,
     fbcon_aty32_putcs, fbcon_cfb32_revc, NULL
 };
+#endif
 
 
 #ifdef CONFIG_FB_COMPAT_XPMAC
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/video/fbcon.c m68k/drivers/video/fbcon.c
--- jes-2.1.105/drivers/video/fbcon.c	Mon Jun  8 20:46:53 1998
+++ m68k/drivers/video/fbcon.c	Mon Jun  8 22:49:18 1998
@@ -83,7 +83,7 @@
 #ifdef CONFIG_MAC
 #include <asm/macints.h>
 #endif
-#ifdef __mc68000__
+#if defined(__mc68000__) || defined(CONFIG_APUS)
 #include <asm/machdep.h>
 #include <asm/setup.h>
 #endif
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/video/fonts.c m68k/drivers/video/fonts.c
--- jes-2.1.105/drivers/video/fonts.c	Tue Mar 24 19:08:14 1998
+++ m68k/drivers/video/fonts.c	Mon Jun  1 10:51:30 1998
@@ -12,7 +12,7 @@
 #include <linux/config.h>
 #include <linux/types.h>
 #include <linux/string.h>
-#ifdef __mc68000__
+#if defined(__mc68000__) || defined(CONFIG_APUS)
 #include <asm/setup.h>
 #endif
 #include "font.h"
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/zorro/Makefile m68k/drivers/zorro/Makefile
--- jes-2.1.105/drivers/zorro/Makefile	Mon Jun  8 20:46:55 1998
+++ m68k/drivers/zorro/Makefile	Mon Jun  8 23:20:13 1998
@@ -1,12 +1,32 @@
 #
-# Makefile for the linux/drivers/zorro/ directory.
+# Makefile for the Zorro bus specific drivers.
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definition is now inherited from the
+# parent makefile.
 #
 
 SUB_DIRS     :=
 MOD_SUB_DIRS := $(SUB_DIRS)
 ALL_SUB_DIRS := $(SUB_DIRS)
 
-L_OBJS   := zorro.o
 L_TARGET := zorro.a
+
+# Nasty trick as nobody references zorrosyms.o, but we still want it linked.
+ifeq ($(CONFIG_MODULES),y)
+O_TARGET = zorro_syms.o
+OX_OBJS  = zorrosyms.o
+O_OBJS   = zorro.o
+L_OBJS   := zorro_syms.o
+else
+L_OBJS   := zorro.o
+endif
+
+ifdef CONFIG_PROC_FS
+L_OBJS   += proc.o
+endif
 
 include $(TOPDIR)/Rules.make
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/zorro/proc.c m68k/drivers/zorro/proc.c
--- jes-2.1.105/drivers/zorro/proc.c	Thu Jan  1 01:00:00 1970
+++ m68k/drivers/zorro/proc.c	Mon Jun  8 01:21:01 1998
@@ -0,0 +1,167 @@
+/*
+ *	$Id: proc.c,v 1.1.2.1 1998/06/07 23:21:01 geert Exp $
+ *
+ *	Procfs interface for the Zorro bus.
+ *
+ *	Copyright (C) 1998 Geert Uytterhoeven
+ *
+ *	Heavily based on the procfs interface for the PCI bus, which is
+ *
+ *	Copyright (C) 1997, 1998 Martin Mares <mj@atrey.karlin.mff.cuni.cz>
+ */
+
+#include <linux/types.h>
+#include <linux/zorro.h>
+#include <linux/proc_fs.h>
+#include <linux/init.h>
+#include <asm/uaccess.h>
+#include <asm/amigahw.h>
+#include <asm/setup.h>
+
+static loff_t
+proc_bus_zorro_lseek(struct file *file, loff_t off, int whence)
+{
+	loff_t new;
+
+	switch (whence) {
+	case 0:
+		new = off;
+		break;
+	case 1:
+		new = file->f_pos + off;
+		break;
+	case 2:
+		new = sizeof(struct ConfigDev) + off;
+		break;
+	default:
+		return -EINVAL;
+	}
+	if (new < 0 || new > sizeof(struct ConfigDev))
+		return -EINVAL;
+	return (file->f_pos = new);
+}
+
+static ssize_t
+proc_bus_zorro_read(struct file *file, char *buf, size_t nbytes, loff_t *ppos)
+{
+	struct inode *ino = file->f_dentry->d_inode;
+	struct proc_dir_entry *dp = ino->u.generic_ip;
+	struct ConfigDev *cd = dp->data;
+	int pos = *ppos;
+
+	if (pos >= sizeof(struct ConfigDev))
+		return 0;
+	if (nbytes >= sizeof(struct ConfigDev))
+		nbytes = sizeof(struct ConfigDev);
+	if (pos + nbytes > sizeof(struct ConfigDev))
+		nbytes = sizeof(struct ConfigDev) - pos;
+	if (copy_to_user(buf, cd, nbytes))
+		return -EFAULT;
+	*ppos += nbytes;
+
+	return nbytes;
+}
+
+static struct file_operations proc_bus_zorro_operations = {
+	proc_bus_zorro_lseek,
+	proc_bus_zorro_read,
+	NULL,		/* write */
+	NULL,		/* readdir */
+	NULL,		/* poll */
+	NULL,		/* ioctl */
+	NULL,		/* mmap */
+	NULL,		/* no special open code */
+	NULL,		/* no special release code */
+	NULL		/* can't fsync */
+};
+
+static struct inode_operations proc_bus_zorro_inode_operations = {
+	&proc_bus_zorro_operations, /* default base directory file-ops */
+	NULL,			/* create */
+	NULL,			/* lookup */
+	NULL,			/* link */
+	NULL,			/* unlink */
+	NULL,			/* symlink */
+	NULL,			/* mkdir */
+	NULL,			/* rmdir */
+	NULL,			/* mknod */
+	NULL,			/* rename */
+	NULL,			/* readlink */
+	NULL,			/* follow_link */
+	NULL,			/* readpage */
+	NULL,			/* writepage */
+	NULL,			/* bmap */
+	NULL,			/* truncate */
+	NULL			/* permission */
+};
+
+int
+get_zorro_dev_info(char *buf, char **start, off_t pos, int count, int wr)
+{
+	u_int slot;
+	off_t at = 0;
+	int len, cnt;
+
+	for (slot = cnt = 0; slot < zorro_num_autocon && count > cnt; slot++) {
+		struct ConfigDev *cd = &zorro_autocon[slot];
+		u16 manuf = cd->cd_Rom.er_Manufacturer;
+		u8 prod = cd->cd_Rom.er_Product;
+		u8 epc;
+		if (manuf == ZORRO_MANUF(ZORRO_PROD_GVP_EPC_BASE) &&
+		    prod == ZORRO_PROD(ZORRO_PROD_GVP_EPC_BASE)) {
+		    /* GVP quirk */
+		    u32 addr = (u32)cd->cd_BoardAddr;
+		    epc = *(u16 *)ZTWO_VADDR(addr+0x8000);
+		} else
+		    epc = 0;
+		len = sprintf(buf, "%02x\t%04x%02x%02x\t%08x\t%08x\t%02x\n",
+			      slot, manuf, prod, epc, (u32)cd->cd_BoardAddr,
+			      cd->cd_BoardSize, cd->cd_Rom.er_Type);
+		at += len;
+		if (at >= pos) {
+			if (!*start) {
+				*start = buf + (pos - (at - len));
+				cnt = at - pos;
+			} else
+				cnt += len;
+			buf += len;
+		}
+	}
+	return (count > cnt) ? cnt : count;
+}
+
+static struct proc_dir_entry proc_zorro_devices = {
+	PROC_BUS_ZORRO_DEVICES, 7, "devices",
+	S_IFREG | S_IRUGO, 1, 0, 0,
+	0, &proc_array_inode_operations,
+	get_zorro_dev_info
+};
+
+static struct proc_dir_entry *proc_bus_zorro_dir;
+
+__initfunc(static int zorro_proc_attach_device(u_int slot))
+{
+	struct proc_dir_entry *entry;
+	char name[4];
+
+	sprintf(name, "%02x", slot);
+	entry = create_proc_entry(name, S_IFREG | S_IRUGO, proc_bus_zorro_dir);
+	if (!entry)
+		return -ENOMEM;
+	entry->ops = &proc_bus_zorro_inode_operations;
+	entry->data = &zorro_autocon[slot];
+	entry->size = sizeof(struct ConfigDev);
+	return 0;
+}
+
+__initfunc(void zorro_proc_init(void))
+{
+	u_int slot;
+
+	if (!MACH_IS_AMIGA || !AMIGAHW_PRESENT(ZORRO))
+		return;
+	proc_bus_zorro_dir = create_proc_entry("zorro", S_IFDIR, proc_bus);
+	proc_register(proc_bus_zorro_dir, &proc_zorro_devices);
+	for (slot = 0; slot < zorro_num_autocon; slot++)
+	    zorro_proc_attach_device(slot);
+}
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/zorro/zorro.c m68k/drivers/zorro/zorro.c
--- jes-2.1.105/drivers/zorro/zorro.c	Mon Jun  8 20:46:55 1998
+++ m68k/drivers/zorro/zorro.c	Mon Jun  8 01:21:02 1998
@@ -1,7 +1,9 @@
 /*
- *    linux/arch/m68k/amiga/zorro.c
+ *    $Id: zorro.c,v 1.1.2.1 1998/06/07 23:21:02 geert Exp $
  *
- *    Copyright (C) 1995 Geert Uytterhoeven
+ *    Zorro Bus Services
+ *
+ *    Copyright (C) 1995-1998 Geert Uytterhoeven
  *
  *    This file is subject to the terms and conditions of the GNU General Public
  *    License.  See the file COPYING in the main directory of this archive
@@ -9,892 +11,22 @@
  */
 
 
-#include <linux/config.h>
 #include <linux/types.h>
 #include <linux/kernel.h>
-#include <linux/string.h>
+#include <linux/init.h>
+#include <linux/zorro.h>
 #include <asm/setup.h>
 #include <asm/bitops.h>
 #include <asm/amigahw.h>
-#include <linux/zorro.h>
-
-
-#ifdef CONFIG_ZORRO
-
-    /*
-     *  Zorro Expansion Device Manufacturers and Products
-     */
-
-struct Manufacturer {
-    const char *Name;
-    u_short Manuf;
-    u_short NumProd;
-    const struct Product *Products;
-};
-
-struct Product {
-    const char *Name;
-    u_char Class;
-    u_char Prod;
-};
-
-struct GVP_Product {
-    const char *Name;
-    u_char Class;
-    u_char EPC;
-};
-
-
-    /*
-     *  Macro's to make life easier
-     */
-
-#define ARRAYSIZE(x)		(sizeof(x)/sizeof(*(x)))
-
-#define BEGIN_PROD(id) \
-    static struct Product Prod_##id[] = {
-#define PROD(name, class, id) \
-    { name, ZORRO_CLASS_##class, ZORRO_PROD(ZORRO_PROD_##id) },
-
-#define BEGIN_GVP_PROD \
-    static struct GVP_Product Ext_Prod_GVP[] = {
-#define GVP_PROD(name, class, id) \
-    { name, ZORRO_CLASS_##class, ZORRO_EPC(ZORRO_PROD_##id) },
-
-#define BEGIN_MANUF \
-    static struct Manufacturer Manufacturers[] = {
-#define MANUF(name, id) \
-    { name, ZORRO_MANUF_##id, ARRAYSIZE(Prod_##id), Prod_##id },
-
-#define END \
-    };
-
-
-    /*
-     *  Recognized Zorro Expansion Devices
-     */
-
-BEGIN_PROD(PACIFIC_PERIPHERALS)
-    PROD("SE 2000 A500", HD, PACIFIC_PERIPHERALS_SE_2000_A500)
-    PROD(NULL, SCSI, PACIFIC_PERIPHERALS_SCSI)
-END
-
-BEGIN_PROD(MACROSYSTEMS_USA_2)
-    PROD("Warp Engine", TURBO_SCSI_RAM, MACROSYSTEMS_WARP_ENGINE)
-END
-
-BEGIN_PROD(KUPKE_1)
-    PROD("Golem RAM Box 2MB", RAM, KUPKE_GOLEM_RAM_BOX_2MB)
-END
-
-BEGIN_PROD(MEMPHIS)
-    PROD("Stormbringer", TURBO, MEMPHIS_STORMBRINGER)
-END
-
-BEGIN_PROD(3_STATE)
-    PROD("Megamix 2000", RAM, 3_STATE_MEGAMIX_2000)
-END
-
-BEGIN_PROD(COMMODORE_BRAUNSCHWEIG)
-    PROD("A2088 XT/A2286 AT", BRIDGE, CBM_A2088_A2286)
-    PROD("A2286 AT", BRIDGE, CBM_A2286)
-    PROD("A4091", SCSI, CBM_A4091_1)
-    PROD("A2386-SX", BRIDGE, CBM_A2386SX_1)
-END
-
-BEGIN_PROD(COMMODORE_WEST_CHESTER_1)
-    PROD("A2090/A2090A", SCSI, CBM_A2090A)
-    PROD("A590/A2091", SCSI, CBM_A590_A2091_1)
-    PROD("A590/A2091", SCSI, CBM_A590_A2091_2)
-    PROD("A2090B 2090 Autoboot", SCSI, CBM_A2090B)
-    PROD("A2060", ARCNET, CBM_A2060)
-    PROD("A590/A2052/A2058/A2091", RAM, CBM_A590_A2052_A2058_A2091)
-    PROD("A560", RAM, CBM_A560_RAM)
-    PROD("A2232 Prototype", MULTIIO, CBM_A2232_PROTOTYPE)
-    PROD("A2232", MULTIIO, CBM_A2232)
-    PROD("A2620 68020/RAM", TURBO_RAM, CBM_A2620)
-    PROD("A2630 68030/RAM", TURBO_RAM, CBM_A2630)
-    PROD("A4091", SCSI, CBM_A4091_2)
-    PROD("A2065", ETHERNET, CBM_A2065_1)
-    PROD("Romulator Card", UNKNOWN, CBM_ROMULATOR)
-    PROD("A3000 Test Fixture", MISC, CBM_A3000_TEST_FIXTURE)
-    PROD("A2386-SX", BRIDGE, CBM_A2386SX_2)
-    PROD("A2065", ETHERNET, CBM_A2065_2)
-END
-
-BEGIN_PROD(COMMODORE_WEST_CHESTER_2)
-    PROD("A2090/A2090A Combitec/MacroSystem", SCSI, CBM_A2090A_CM)
-END
-
-BEGIN_PROD(PROGRESSIVE_PERIPHERALS_AND_SYSTEMS_2)
-    PROD("EXP8000", RAM, PPS_EXP8000)
-END
-
-BEGIN_PROD(KOLFF_COMPUTER_SUPPLIES)
-    PROD("KCS Power PC Board", BRIDGE, KCS_POWER_PC_BOARD)
-END
-
-BEGIN_PROD(CARDCO_1)
-    PROD("Kronos 2000", SCSI, CARDCO_KRONOS_2000_1)
-    PROD("A1000", SCSI, CARDCO_A1000_1)
-    PROD("Escort", SCSI, CARDCO_ESCORT)
-    PROD("A2410 HiRes", GFX, CARDCO_A2410)
-END
-
-BEGIN_PROD(A_SQUARED)
-    PROD("Live! 2000", VIDEO, A_SQUARED_LIVE_2000)
-END
-
-BEGIN_PROD(COMSPEC_COMMUNICATIONS)
-    PROD("AX2000", RAM, COMSPEC_COMMUNICATIONS_AX2000)
-END
-
-BEGIN_PROD(ANAKIN_RESEARCH)
-    PROD("Easyl", TABLET, ANAKIN_RESEARCH_EASYL)
-END
-
-BEGIN_PROD(MICROBOTICS)
-    PROD("StarBoard II", RAM, MICROBOTICS_STARBOARD_II)
-    PROD("StarDrive", SCSI, MICROBOTICS_STARDRIVE)
-    PROD("8-Up (Rev A)", RAM, MICROBOTICS_8_UP_A)
-    PROD("8-Up (Rev Z)", RAM, MICROBOTICS_8_UP_Z)
-    PROD("Delta", RAM, MICROBOTICS_DELTA_RAM)
-    PROD("8-Star", RAM, MICROBOTICS_8_STAR_RAM)
-    PROD("8-Star", MISC, MICROBOTICS_8_STAR)
-    PROD("VXL RAM*32", RAM, MICROBOTICS_VXL_RAM_32)
-    PROD("VXL-30", TURBO, MICROBOTICS_VXL_68030)
-    PROD("Delta", MISC, MICROBOTICS_DELTA)
-    PROD("MBX 1200/1200z", RAM, MICROBOTICS_MBX_1200_1200Z_RAM)
-    PROD("Hardframe 2000", SCSI, MICROBOTICS_HARDFRAME_2000_1)
-    PROD("Hardframe 2000", SCSI, MICROBOTICS_HARDFRAME_2000_2)
-    PROD("MBX 1200/1200z", MISC, MICROBOTICS_MBX_1200_1200Z)
-END
-
-BEGIN_PROD(ACCESS_ASSOCIATES_ALEGRA)
-END
-
-BEGIN_PROD(EXPANSION_TECHNOLOGIES)
-END
-
-BEGIN_PROD(ASDG)
-    PROD(NULL, RAM, ASDG_MEMORY_1)
-    PROD(NULL, RAM, ASDG_MEMORY_2)
-    PROD("EB-920 Lan Rover", ETHERNET, ASDG_EB920_LAN_ROVER)
-    PROD("GPIB/Dual IEEE-488/Twin-X", MULTIIO, ASDG_GPIB_DUALIEEE488_TWIN_X)
-END
-
-BEGIN_PROD(IMTRONICS_1)
-    PROD("Hurricane 2800", TURBO_RAM, IMTRONICS_HURRICANE_2800_1)
-    PROD("Hurricane 2800", TURBO_RAM, IMTRONICS_HURRICANE_2800_2)
-END
-
-BEGIN_PROD(CBM_UNIVERSITY_OF_LOWELL)
-    PROD("A2410 HiRes", GFX, CBM_A2410)
-END
-
-BEGIN_PROD(AMERISTAR)
-    PROD("A2065", ETHERNET, AMERISTAR_A2065)
-    PROD("A560", ARCNET, AMERISTAR_A560)
-    PROD("A4066", ETHERNET, AMERISTAR_A4066)
-END
-
-BEGIN_PROD(SUPRA)
-    PROD("SupraDrive 4x4", SCSI, SUPRA_SUPRADRIVE_4x4)
-    PROD("1000", RAM, SUPRA_1000_RAM)
-    PROD("2000 DMA", SCSI, SUPRA_2000_DMA)
-    PROD("500", SCSI_RAM, SUPRA_500)
-    PROD("500", SCSI, SUPRA_500_SCSI)
-    PROD("500XP/2000", RAM, SUPRA_500XP_2000_RAM)
-    PROD("500RX/2000", RAM, SUPRA_500RX_2000_RAM)
-    PROD("2400zi", MODEM, SUPRA_2400ZI)
-    PROD("500XP/SupraDrive WordSync", SCSI, SUPRA_500XP_SUPRADRIVE_WORDSYNC)
-    PROD("SupraDrive WordSync II", SCSI, SUPRA_SUPRADRIVE_WORDSYNC_II)
-    PROD("2400zi+", MODEM, SUPRA_2400ZIPLUS)
-END
-
-BEGIN_PROD(COMPUTER_SYSTEMS_ASSOCIATES)
-    PROD("Magnum 40", TURBO_SCSI, CSA_MAGNUM)
-    PROD("12 Gauge", SCSI, CSA_12_GAUGE)
-END
-
-BEGIN_PROD(MARC_MICHAEL_GROTH)
-END
-
-BEGIN_PROD(M_TECH)
-    PROD("AT500", RAM, MTEC_AT500_1)
-END
-
-BEGIN_PROD(GREAT_VALLEY_PRODUCTS_1)
-    PROD("Impact Series I", SCSI_RAM, GVP_IMPACT_SERIES_I)
-END
-
-BEGIN_PROD(BYTEBOX)
-    PROD("A500", UNKNOWN, BYTEBOX_A500)
-END
-
-BEGIN_PROD(DKB_POWER_COMPUTING)
-    PROD("SecureKey", UNKNOWN, DKB_POWER_COMPUTING_SECUREKEY)
-    PROD("DKM 3128", RAM, DKB_POWER_COMPUTING_DKM_3128)
-    PROD("Rapid Fire", SCSI, DKB_POWER_COMPUTING_RAPID_FIRE)
-    PROD("DKM 1202", FPU_RAM, DKB_POWER_COMPUTING_DKM_1202)
-    PROD("Cobra/Viper II 68EC030", TURBO, DKB_POWER_COMPUTING_COBRA_VIPER_II_68EC030)
-    PROD("WildFire 060", TURBO, DKB_POWER_COMPUTING_WILDFIRE_060_1)
-    PROD("WildFire 060", TURBO, DKB_POWER_COMPUTING_WILDFIRE_060_2)
-END
-
-BEGIN_PROD(GREAT_VALLEY_PRODUCTS_2)
-    PROD("Impact Series I (4K)", SCSI, GVP_IMPACT_SERIES_I_4K)
-    PROD("Impact Series I (16K/2)", SCSI, GVP_IMPACT_SERIES_I_16K_2)
-    PROD("Impact Series I (16K/2)", SCSI, GVP_IMPACT_SERIES_I_16K_3)
-    PROD("Impact 3001", IDE, GVP_IMPACT_3001_IDE_1)
-    PROD("Impact 3001", RAM, GVP_IMPACT_3001_RAM)
-    PROD("Impact Series II", RAM, GVP_IMPACT_SERIES_II_RAM_1)
-/*  PROD(NULL, UNKNOWN, GVP_EPC_BASE) */
-    PROD("Impact 3001", IDE, GVP_IMPACT_3001_IDE_2)
-/*  PROD("A2000 030", TURBO, GVP_A2000_030) */
-/*  PROD("GForce 040", TURBO_SCSI, GFORCE_040_SCSI_2) */
-    PROD("GForce 040/060", TURBO_SCSI, GVP_GFORCE_040_060)
-    PROD("Impact Vision 24", GFX, GVP_IMPACT_VISION_24)
-    PROD("GForce 040", TURBO, GVP_GFORCE_040_2)
-END
-
-BEGIN_GVP_PROD					/* ZORRO_PROD_GVP_EPC_BASE */
-    GVP_PROD("GForce 040", TURBO, GVP_GFORCE_040_1)
-    GVP_PROD("GForce 040", TURBO_SCSI, GVP_GFORCE_040_SCSI_1)
-    GVP_PROD("A1291", SCSI, GVP_A1291)
-    GVP_PROD("Combo 030 R4", TURBO, GVP_COMBO_030_R4)
-    GVP_PROD("Combo 030 R4", TURBO_SCSI, GVP_COMBO_030_R4_SCSI)
-    GVP_PROD("Phone Pak", UNKNOWN, GVP_PHONEPAK)
-    GVP_PROD("IO-Extender", MULTIIO, GVP_IO_EXTENDER)
-    GVP_PROD("GForce 030", TURBO, GVP_GFORCE_030)
-    GVP_PROD("GForce 030", TURBO_SCSI, GVP_GFORCE_030_SCSI)
-    GVP_PROD("A530", TURBO, GVP_A530)
-    GVP_PROD("A530", TURBO_SCSI, GVP_A530_SCSI)
-    GVP_PROD("Combo 030 R3", TURBO, GVP_COMBO_030_R3)
-    GVP_PROD("Combo 030 R3", TURBO_SCSI, GVP_COMBO_030_R3_SCSI)
-    GVP_PROD("Series-II", SCSI, GVP_SERIES_II)
-END
-
-BEGIN_PROD(CALIFORNIA_ACCESS_SYNERGY)
-    PROD("Malibu", SCSI, CALIFORNIA_ACCESS_SYNERGY_MALIBU)
-END
-
-BEGIN_PROD(XETEC)
-    PROD("FastCard", SCSI, XETEC_FASTCARD)
-    PROD("FastCard", RAM, XETEC_FASTCARD_RAM)
-    PROD("FastCard Plus", SCSI, XETEC_FASTCARD_PLUS)
-END
-
-BEGIN_PROD(PROGRESSIVE_PERIPHERALS_AND_SYSTEMS)
-    PROD("Mercury", TURBO, PPS_MERCURY)
-    PROD("A3000 68040", TURBO, PPS_A3000_68040)
-    PROD("A2000 68040", TURBO, PPS_A2000_68040)
-    PROD("Zeus", TURBO_SCSI_RAM, PPS_ZEUS)
-    PROD("A500 68040", TURBO, PPS_A500_68040)
-END
-
-BEGIN_PROD(XEBEC)
-END
-
-BEGIN_PROD(SPIRIT_TECHNOLOGY)
-    PROD("Insider IN1000", RAM, SPIRIT_TECHNOLOGY_INSIDER_IN1000)
-    PROD("Insider IN500", RAM, SPIRIT_TECHNOLOGY_INSIDER_IN500)
-    PROD("SIN500", RAM, SPIRIT_TECHNOLOGY_SIN500)
-    PROD("HDA 506", HD, SPIRIT_TECHNOLOGY_HDA_506)
-    PROD("AX-S", MISC, SPIRIT_TECHNOLOGY_AX_S)
-    PROD("OctaByte", RAM, SPIRIT_TECHNOLOGY_OCTABYTE)
-    PROD("Inmate", SCSI_RAM, SPIRIT_TECHNOLOGY_INMATE)
-END
-
-BEGIN_PROD(SPIRIT_TECHNOLOGY_2)
-END
-
-BEGIN_PROD(BSC_ALFADATA_1)
-    PROD("ALF 3", SCSI, BSC_ALF_3_1)
-END
-
-BEGIN_PROD(BSC_ALFADATA_2)
-    PROD("ALF 2", SCSI, BSC_ALF_2_1)
-    PROD("ALF 2", SCSI, BSC_ALF_2_2)
-    PROD("ALF 3", SCSI, BSC_ALF_3_2)
-END
-
-BEGIN_PROD(CARDCO_2)
-    PROD("Kronos", SCSI, CARDCO_KRONOS_2000_2)
-    PROD("A1000", SCSI, CARDCO_A1000_2)
-END
-
-BEGIN_PROD(JOCHHEIM)
-    PROD(NULL, RAM, JOCHHEIM_RAM)
-END
-
-BEGIN_PROD(CHECKPOINT_TECHNOLOGIES)
-    PROD("Serial Solution", SERIAL, CHECKPOINT_TECHNOLOGIES_SERIAL_SOLUTION)
-END
-
-BEGIN_PROD(EDOTRONIK)
-    PROD("IEEE-488 Interface Board", UNKNOWN, EDOTRONIK_IEEE_488)
-    PROD("CBM-8032 Board", UNKNOWN, EDOTRONIK_8032)
-    PROD(NULL, SERIAL, EDOTRONIK_MULTISERIAL)
-    PROD("24Bit Realtime Video Digitizer", UNKNOWN, EDOTRONIK_VIDEODIGITIZER)
-    PROD("32Bit Parallel I/O Interface", UNKNOWN, EDOTRONIK_PARALLEL_IO)
-    PROD("PIC Prototyping Board", UNKNOWN, EDOTRONIK_PIC_PROTOYPING)
-    PROD("16 Channel ADC Interface", UNKNOWN, EDOTRONIK_ADC)
-    PROD("VME-Bus Controller", UNKNOWN, EDOTRONIK_VME)
-    PROD("DSP96000 Realtime Data Acquisition", DSP, EDOTRONIK_DSP96000)
-END
-
-BEGIN_PROD(NES_INC)
-    PROD(NULL, RAM, NES_INC_RAM)
-END
-
-BEGIN_PROD(ICD)
-    PROD("Advantage 2000", SCSI, ICD_ADVANTAGE_2000_SCSI)
-    PROD("Advantage", IDE, ICD_ADVANTAGE_2000_SCSI)
-    PROD("Advantage 2080", RAM, ICD_ADVANTAGE_2080_RAM)
-END
-
-BEGIN_PROD(KUPKE_2)
-    PROD("Omti", HD, KUPKE_OMTI)
-    PROD("Golem SCSI-II", SCSI, KUPKE_SCSI_II)
-    PROD("Golem Box", UNKNOWN, KUPKE_GOLEM_BOX)
-    PROD("030/882", TURBO, KUPKE_030_882)
-    PROD("Golem", SCSI, KUPKE_SCSI_AT)
-END
-
-BEGIN_PROD(GREAT_VALLEY_PRODUCTS_3)
-    PROD("A2000-RAM8/2", MISC, GVP_A2000_RAM8)
-    PROD("Impact Series II", RAM, GVP_IMPACT_SERIES_II_RAM_2)
-END
-
-BEGIN_PROD(INTERWORKS_NETWORK)
-END
-
-BEGIN_PROD(HARDITAL_SYNTHESIS)
-    PROD("TQM 68030+68882", TURBO, HARDITAL_SYNTHESIS_TQM_68030_68882)
-END
-
-BEGIN_PROD(APPLIED_ENGINEERING)
-    PROD("DL2000", MODEM, APPLIED_ENGINEERING_DL2000)
-    PROD("RAM Works", RAM, APPLIED_ENGINEERING_RAM_WORKS)
-END
-
-BEGIN_PROD(BSC_ALFADATA_3)
-    PROD("Oktagon 2008", SCSI, BSC_OKTAGON_2008)
-    PROD("Tandem AT-2008/508", IDE, BSC_TANDEM_AT_2008_508)
-    PROD("Alpha RAM 1200", RAM, BSC_ALFA_RAM_1200)
-    PROD("Oktagon 2008", RAM, BSC_OKTAGON_2008_RAM)
-    PROD("MultiFace I", MULTIIO, BSC_MULTIFACE_I)
-    PROD("MultiFace II", MULTIIO, BSC_MULTIFACE_II)
-    PROD("MultiFace III", MULTIIO, BSC_MULTIFACE_III)
-    PROD("Framebuffer", MISC, BSC_FRAMEBUFFER)
-    PROD("Graffiti", GFXRAM, BSC_GRAFFITI_RAM)
-    PROD("Graffiti", GFX, BSC_GRAFFITI_REG)
-    PROD("ISDN MasterCard", ISDN, BSC_ISDN_MASTERCARD)
-    PROD("ISDN MasterCard II", ISDN, BSC_ISDN_MASTERCARD_II)
-END
-
-BEGIN_PROD(PHOENIX)
-    PROD("ST506", HD, PHOENIX_ST506)
-    PROD(NULL, SCSI, PHOENIX_SCSI)
-    PROD(NULL, RAM, PHOENIX_RAM)
-END
-
-BEGIN_PROD(ADVANCED_STORAGE_SYSTEMS)
-    PROD("Nexus", SCSI, ADVANCED_STORAGE_SYSTEMS_NEXUS)
-    PROD("Nexus", RAM, ADVANCED_STORAGE_SYSTEMS_NEXUS_RAM)
-END
-
-BEGIN_PROD(IMPULSE)
-    PROD("FireCracker 24", GFX, IMPULSE_FIRECRACKER_24)
-END
-
-BEGIN_PROD(IVS)
-    PROD("GrandSlam PIC 2", RAM, IVS_GRANDSLAM_PIC_2)
-    PROD("GrandSlam PIC 1", RAM, IVS_GRANDSLAM_PIC_1)
-    PROD("OverDrive", HD, IVS_OVERDRIVE)
-    PROD("TrumpCard Classic", SCSI, IVS_TRUMPCARD_CLASSIC)
-    PROD("TrumpCard Pro/GrandSlam", SCSI, IVS_TRUMPCARD_PRO_GRANDSLAM)
-    PROD("Meta-4", RAM, IVS_META_4)
-    PROD("Wavetools", AUDIO, IVS_WAVETOOLS)
-    PROD("Vector", SCSI, IVS_VECTOR_1)
-    PROD("Vector", SCSI, IVS_VECTOR_2)
-END
-
-BEGIN_PROD(VECTOR_1)
-    PROD("Connection", MULTIIO, VECTOR_CONNECTION_1)
-END
-
-BEGIN_PROD(XPERT_PRODEV)
-    PROD("Visiona", GFXRAM, XPERT_PRODEV_VISIONA_RAM)
-    PROD("Visiona", GFX, XPERT_PRODEV_VISIONA_REG)
-    PROD("Merlin", GFXRAM, XPERT_PRODEV_MERLIN_RAM)
-    PROD("Merlin", GFX, XPERT_PRODEV_MERLIN_REG_1)
-    PROD("Merlin", GFX, XPERT_PRODEV_MERLIN_REG_2)
-END
-
-BEGIN_PROD(HYDRA_SYSTEMS)
-    PROD("Amiganet", ETHERNET, HYDRA_SYSTEMS_AMIGANET)
-END
-
-BEGIN_PROD(SUNRIZE_INDUSTRIES)
-    PROD("AD1012", AUDIO, SUNRIZE_INDUSTRIES_AD1012)
-    PROD("AD516", AUDIO, SUNRIZE_INDUSTRIES_AD516)
-    PROD("DD512", AUDIO, SUNRIZE_INDUSTRIES_DD512)
-END
-
-BEGIN_PROD(TRICERATOPS)
-    PROD(NULL, MULTIIO, TRICERATOPS_MULTI_IO)
-END
-
-BEGIN_PROD(APPLIED_MAGIC)
-    PROD("DMI Resolver", GFX, APPLIED_MAGIC_DMI_RESOLVER)
-    PROD("Digital Broadcaster", VIDEO, APPLIED_MAGIC_DIGITAL_BROADCASTER)
-END
-
-BEGIN_PROD(GFX_BASE)
-    PROD("GDA-1 VRAM", GFX, GFX_BASE_GDA_1_VRAM)
-    PROD("GDA-1", GFX, GFX_BASE_GDA_1)
-END
-
-BEGIN_PROD(ROCTEC)
-    PROD("RH 800C", HD, ROCTEC_RH_800C)
-    PROD("RH 800C", RAM, ROCTEC_RH_800C_RAM)
-END
-
-BEGIN_PROD(KATO)
-    PROD("Melody MPEG", AUDIO, KATO_MELODY)
-    PROD("Rainbow II", GFX, HELFRICH_RAINBOW_II)	/* ID clash!! */
-    PROD("Rainbow III", GFX, HELFRICH_RAINBOW_III)	/* ID clash!! */
-END
-
-BEGIN_PROD(ATLANTIS)
-END
-
-BEGIN_PROD(PROTAR)
-END
-
-BEGIN_PROD(ACS)
-END
-
-BEGIN_PROD(SOFTWARE_RESULTS_ENTERPRISES)
-    PROD("Golden Gate 2 Bus+", BRIDGE, SOFTWARE_RESULTS_ENTERPRISES_GOLDEN_GATE_2_BUS_PLUS)
-END
-
-BEGIN_PROD(MASOBOSHI)
-    PROD("MasterCard SC201", RAM, MASOBOSHI_MASTER_CARD_SC201)
-    PROD("MasterCard MC702", SCSI_IDE, MASOBOSHI_MASTER_CARD_MC702)
-    PROD("MVD 819", UNKNOWN, MASOBOSHI_MVD_819)
-END
-
-BEGIN_PROD(MAINHATTAN_DATA)
-    PROD(NULL, IDE, MAINHATTAN_DATA_IDE)
-END
-
-BEGIN_PROD(VILLAGE_TRONIC)
-    PROD("Domino", GFXRAM, VILLAGE_TRONIC_DOMINO_RAM)
-    PROD("Domino", GFX, VILLAGE_TRONIC_DOMINO_REG)
-    PROD("Domino 16M Prototype", GFX, VILLAGE_TRONIC_DOMINO_16M_PROTOTYPE)
-    PROD("Picasso II/II+", GFXRAM, VILLAGE_TRONIC_PICASSO_II_II_PLUS_RAM)
-    PROD("Picasso II/II+", GFX, VILLAGE_TRONIC_PICASSO_II_II_PLUS_REG)
-    PROD("Picasso II/II+ (Segmented Mode)", GFX, VILLAGE_TRONIC_PICASSO_II_II_PLUS_SEGMENTED_MODE)
-    PROD("Picasso IV Z2", GFXRAM, VILLAGE_TRONIC_PICASSO_IV_Z2_MEM1)
-    PROD("Picasso IV Z2", GFXRAM, VILLAGE_TRONIC_PICASSO_IV_Z2_MEM2)
-    PROD("Picasso IV Z2", GFX, VILLAGE_TRONIC_PICASSO_IV_Z2_REG)
-    PROD("Picasso IV Z3", GFX, VILLAGE_TRONIC_PICASSO_IV_Z3)
-    PROD("Ariadne", ETHERNET_PARALLEL, VILLAGE_TRONIC_ARIADNE)
-END
-
-BEGIN_PROD(UTILITIES_UNLIMITED)
-    PROD("Emplant Deluxe", MACEMU, UTILITIES_UNLIMITED_EMPLANT_DELUXE)
-    PROD("Emplant Deluxe", MACEMU, UTILITIES_UNLIMITED_EMPLANT_DELUXE2)
-END
-
-BEGIN_PROD(AMITRIX)
-    PROD(NULL, MULTIIO, AMITRIX_MULTI_IO)
-    PROD("CD-RAM", RAM, AMITRIX_CD_RAM)
-END
-
-BEGIN_PROD(ARMAX)
-    PROD("OmniBus", GFX, ARMAX_OMNIBUS)
-END
-
-BEGIN_PROD(ZEUS)
-    PROD("Spider", VIDEO, ZEUS_SPIDER)
-END
-
-BEGIN_PROD(NEWTEK)
-    PROD("VideoToaster", VIDEO, NEWTEK_VIDEOTOASTER)
-END
-
-BEGIN_PROD(M_TECH_GERMANY)
-    PROD("AT500", IDE, MTEC_AT500_2)
-    PROD("68030", TURBO, MTEC_68030)
-    PROD("68020i", TURBO, MTEC_68020I)
-    PROD("A1200 T68030 RTC", TURBO, MTEC_A1200_T68030_RTC)
-    PROD("Viper Mk V/E-Matrix 530", TURBO_RAM, MTEC_VIPER_MK_V_E_MATRIX_530)
-    PROD("8MB", RAM, MTEC_8_MB_RAM)
-    PROD("Viper Mk V/E-Matrix 530 SCSI/IDE", SCSI_IDE, MTEC_VIPER_MK_V_E_MATRIX_530_SCSI_IDE)
-END
-
-BEGIN_PROD(GREAT_VALLEY_PRODUCTS_4)
-    PROD("EGS 28/24 Spectrum", GFX, GVP_EGS_28_24_SPECTRUM_REG)
-    PROD("EGS 28/24 Spectrum", GFXRAM, GVP_EGS_28_24_SPECTRUM_RAM)
-END
-
-BEGIN_PROD(APOLLO_1)
-    PROD("A1200", FPU_RAM, APOLLO_A1200)
-END
-
-BEGIN_PROD(HELFRICH_2)
-    PROD("Piccolo", GFXRAM, HELFRICH_PICCOLO_RAM)
-    PROD("Piccolo", GFX, HELFRICH_PICCOLO_REG)
-    PROD("PeggyPlus MPEG", VIDEO, HELFRICH_PEGGY_PLUS_MPEG)
-    PROD("VideoCruncher", VIDEO, HELFRICH_VIDEOCRUNCHER)
-    PROD("Piccolo SD64", GFXRAM, HELFRICH_SD64_RAM)
-    PROD("Piccolo SD64", GFX, HELFRICH_SD64_REG)
-END
-
-BEGIN_PROD(MACROSYSTEMS_USA)
-    PROD("Warp Engine 40xx", TURBO_SCSI_RAM, MACROSYSTEMS_WARP_ENGINE_40xx)
-END
-
-BEGIN_PROD(ELBOX_COMPUTER)
-    PROD("1200/4", RAM, ELBOX_COMPUTER_1200_4)
-END
-
-BEGIN_PROD(HARMS_PROFESSIONAL)
-    PROD("030 Plus", TURBO, HARMS_PROFESSIONAL_030_PLUS)
-    PROD("3500 Professional", TURBO_RAM, HARMS_PROFESSIONAL_3500)
-END
-
-BEGIN_PROD(MICRONIK)
-    PROD("RCA 120", RAM, MICRONIK_RCA_120)
-END
-
-BEGIN_PROD(MICRONIK2)
-    PROD("Z3i A1200 Zorro III + SCSI", SCSI, MICRONIK2_Z3I)
-END
-
-BEGIN_PROD(MEGAMICRO)
-    PROD("SCRAM 500", SCSI, MEGAMICRO_SCRAM_500)
-    PROD("SCRAM 500", RAM, MEGAMICRO_SCRAM_500_RAM)
-END
-
-BEGIN_PROD(IMTRONICS_2)
-    PROD("Hurricane 2800", TURBO_RAM, IMTRONICS_HURRICANE_2800_3)
-    PROD("Hurricane 2800", TURBO_RAM, IMTRONICS_HURRICANE_2800_4)
-END
-
-BEGIN_PROD(INDIVIDUAL_COMPUTERS)
-    PROD("Buddha", IDE, INDIVIDUAL_COMPUTERS_BUDDHA)
-    PROD("Catweasel", IDE_FLOPPY, INDIVIDUAL_COMPUTERS_CATWEASEL)
-END
-
-BEGIN_PROD(KUPKE_3)
-    PROD("Golem HD 3000", HD, KUPKE_GOLEM_HD_3000)
-END
-
-BEGIN_PROD(ITH)
-    PROD("ISDN-Master II", ISDN, ITH_ISDN_MASTER_II)
-END
-
-BEGIN_PROD(VMC)
-    PROD("ISDN Blaster Z2", ISDN, VMC_ISDN_BLASTER_Z2)
-    PROD("HyperCom 4", MULTIIO, VMC_HYPERCOM_4)
-END
-
-BEGIN_PROD(INFORMATION)
-    PROD("ISDN Engine I", ISDN, INFORMATION_ISDN_ENGINE_I)
-END
-
-BEGIN_PROD(VORTEX)
-    PROD("Golden Gate 80386SX", BRIDGE, VORTEX_GOLDEN_GATE_80386SX)
-    PROD("Golden Gate", RAM, VORTEX_GOLDEN_GATE_RAM)
-    PROD("Golden Gate 80486", BRIDGE, VORTEX_GOLDEN_GATE_80486)
-END
-
-BEGIN_PROD(EXPANSION_SYSTEMS)
-    PROD("DataFlyer 4000SX", SCSI, EXPANSION_SYSTEMS_DATAFLYER_4000SX)
-    PROD("DataFlyer 4000SX", RAM, EXPANSION_SYSTEMS_DATAFLYER_4000SX_RAM)
-END
-
-BEGIN_PROD(READYSOFT)
-    PROD("AMax II/IV", MACEMU, READYSOFT_AMAX_II_IV)
-END
-
-BEGIN_PROD(PHASE5)
-    PROD("Blizzard", RAM, PHASE5_BLIZZARD_RAM)
-    PROD("Blizzard", TURBO, PHASE5_BLIZZARD)
-    PROD("Blizzard 1220-IV", TURBO, PHASE5_BLIZZARD_1220_IV)
-    PROD("FastLane Z3", RAM, PHASE5_FASTLANE_Z3_RAM)
-    PROD("Blizzard 1230-II/Fastlane Z3/CyberSCSI/CyberStorm060", TURBO_SCSI, PHASE5_BLIZZARD_1230_II_FASTLANE_Z3_CYBERSCSI_CYBERSTORM060)
-    PROD("Blizzard 1220/CyberStorm", TURBO_SCSI, PHASE5_BLIZZARD_1220_CYBERSTORM)
-    PROD("Blizzard 1230", TURBO, PHASE5_BLIZZARD_1230)
-    PROD("Blizzard 1230-IV/1260", TURBO, PHASE5_BLIZZARD_1230_IV_1260)
-    PROD("Blizzard 2060", TURBO, PHASE5_BLIZZARD_2060)
-    PROD("CyberStorm Mk II", FLASHROM, PHASE5_CYBERSTORM_MK_II)
-    PROD("CyberVision64", GFX, PHASE5_CYBERVISION64)
-    PROD("CyberVision64-3D Prototype", GFX, PHASE5_CYBERVISION64_3D_PROTOTYPE)
-    PROD("CyberVision64-3D", GFX, PHASE5_CYBERVISION64_3D)
-    PROD("CyberStorm Mk III", TURBO_SCSI, PHASE5_CYBERSTORM_MK_III)
-    PROD("Blizzard 603e+", TURBO_SCSI, PHASE5_BLIZZARD_603E_PLUS)
-END
-
-BEGIN_PROD(DPS)
-    PROD("Personal Animation Recorder", VIDEO, DPS_PERSONAL_ANIMATION_RECORDER)
-END
-
-BEGIN_PROD(APOLLO_2)
-    PROD("A620 68020", TURBO, APOLLO_A620_68020_1)
-    PROD("A620 68020", TURBO, APOLLO_A620_68020_2)
-END
-
-BEGIN_PROD(APOLLO_3)
-    PROD("AT-Apollo", UNKNOWN, APOLLO_AT_APOLLO)
-    PROD("1230/1240/1260/2030/4040/4060", TURBO, APOLLO_1230_1240_1260_2030_4040_4060)
-END
-
-BEGIN_PROD(PETSOFF_LP)
-    PROD("Delfina", AUDIO, PETSOFF_LP_DELFINA)
-    PROD("Delfina Lite", AUDIO, PETSOFF_LP_DELFINA_LITE)
-END
-
-BEGIN_PROD(UWE_GERLACH)
-    PROD("RAM/ROM", MISC, UWE_GERLACH_RAM_ROM)
-END
-
-BEGIN_PROD(ACT)
-    PROD("Prelude", AUDIO, ACT_PRELUDE)
-END
-
-BEGIN_PROD(MACROSYSTEMS_GERMANY)
-    PROD("Maestro", AUDIO, MACROSYSTEMS_MAESTRO)
-    PROD("VLab", VIDEO, MACROSYSTEMS_VLAB)
-    PROD("Maestro Pro", AUDIO, MACROSYSTEMS_MAESTRO_PRO)
-    PROD("Retina", GFX, MACROSYSTEMS_RETINA)
-    PROD("MultiEvolution", SCSI, MACROSYSTEMS_MULTI_EVOLUTION)
-    PROD("Toccata", AUDIO, MACROSYSTEMS_TOCCATA)
-    PROD("Retina Z3", GFX, MACROSYSTEMS_RETINA_Z3)
-    PROD("VLab Motion", VIDEO, MACROSYSTEMS_VLAB_MOTION)
-    PROD("Altais", GFX, MACROSYSTEMS_ALTAIS)
-    PROD("Falcon '040", TURBO, MACROSYSTEMS_FALCON_040)
-END
-
-BEGIN_PROD(COMBITEC)
-END
-
-BEGIN_PROD(SKI_PERIPHERALS)
-    PROD("MAST Fireball", SCSI, SKI_PERIPHERALS_MAST_FIREBALL)
-    PROD("SCSI/Dual Serial", SCSI_SERIAL, SKI_PERIPHERALS_SCSI_DUAL_SERIAL)
-END
-
-BEGIN_PROD(REIS_WARE_2)
-    PROD("Scan King", SCANNER, REIS_WARE_SCAN_KING)
-END
-
-BEGIN_PROD(CAMERON)
-    PROD("Personal A4", SCANNER, CAMERON_PERSONAL_A4)
-END
-
-BEGIN_PROD(REIS_WARE)
-    PROD("Handyscanner", SCANNER, REIS_WARE_HANDYSCANNER)
-END
-
-BEGIN_PROD(PHOENIX_2)
-    PROD("ST506", HD, PHOENIX_ST506_2)
-    PROD(NULL, SCSI, PHOENIX_SCSI_2)
-    PROD(NULL, RAM, PHOENIX_RAM_2)
-END
-
-BEGIN_PROD(COMBITEC_2)
-    PROD(NULL, HD, COMBITEC_HD)
-    PROD("SRAM", RAM, COMBITEC_SRAM)
-END
-
-BEGIN_PROD(HACKER)	/* Unused */
-END
-
-
-BEGIN_MANUF
-    MANUF("Pacific Peripherals", PACIFIC_PERIPHERALS)
-    MANUF("MacroSystems USA", MACROSYSTEMS_USA_2)
-    MANUF("Kupke", KUPKE_1)
-    MANUF("Memphis", MEMPHIS)
-    MANUF("3-State", 3_STATE)
-    MANUF("Commodore Braunschweig", COMMODORE_BRAUNSCHWEIG)
-    MANUF("Commodore West Chester", COMMODORE_WEST_CHESTER_1)
-    MANUF("Commodore West Chester", COMMODORE_WEST_CHESTER_2)
-    MANUF("Progressive Peripherals & Systems", PROGRESSIVE_PERIPHERALS_AND_SYSTEMS_2)
-    MANUF("Kolff Computer Supplies", KOLFF_COMPUTER_SUPPLIES)
-    MANUF("Cardco Ltd.", CARDCO_1)
-    MANUF("A-Squared", A_SQUARED)
-    MANUF("Comspec Communications", COMSPEC_COMMUNICATIONS)
-    MANUF("Anakin Research", ANAKIN_RESEARCH)
-    MANUF("Microbotics", MICROBOTICS)
-    MANUF("Access Associates Alegra", ACCESS_ASSOCIATES_ALEGRA)
-    MANUF("Expansion Technologies (Pacific Cypress)", EXPANSION_TECHNOLOGIES)
-    MANUF("ASDG", ASDG)
-    MANUF("Ronin/Imtronics", IMTRONICS_1)
-    MANUF("Commodore/University of Lowell", CBM_UNIVERSITY_OF_LOWELL)
-    MANUF("Ameristar", AMERISTAR)
-    MANUF("Supra", SUPRA)
-    MANUF("Computer Systems Assosiates", COMPUTER_SYSTEMS_ASSOCIATES)
-    MANUF("Marc Michael Groth", MARC_MICHAEL_GROTH)
-    MANUF("M-Tech", M_TECH)
-    MANUF("Great Valley Products", GREAT_VALLEY_PRODUCTS_1)
-    MANUF("ByteBox", BYTEBOX)
-    MANUF("DKB/Power Computing", DKB_POWER_COMPUTING)
-    MANUF("Great Valley Products", GREAT_VALLEY_PRODUCTS_2)
-    MANUF("California Access (Synergy)", CALIFORNIA_ACCESS_SYNERGY)
-    MANUF("Xetec", XETEC)
-    MANUF("Progressive Peripherals & Systems", PROGRESSIVE_PERIPHERALS_AND_SYSTEMS)
-    MANUF("Xebec", XEBEC)
-    MANUF("Spirit Technology", SPIRIT_TECHNOLOGY)
-    MANUF("Spirit Technology", SPIRIT_TECHNOLOGY_2)
-    MANUF("BSC/Alfadata", BSC_ALFADATA_1)
-    MANUF("BSC/Alfadata", BSC_ALFADATA_2)
-    MANUF("Cardco Ltd.", CARDCO_2)
-    MANUF("Jochheim", JOCHHEIM)
-    MANUF("Checkpoint Technologies", CHECKPOINT_TECHNOLOGIES)
-    MANUF("Edotronik", EDOTRONIK)
-    MANUF("NES Inc.", NES_INC)
-    MANUF("ICD", ICD)
-    MANUF("Kupke", KUPKE_2)
-    MANUF("Great Valley Products", GREAT_VALLEY_PRODUCTS_3)
-    MANUF("Interworks Network", INTERWORKS_NETWORK)
-    MANUF("Hardital Synthesis", HARDITAL_SYNTHESIS)
-    MANUF("Applied Engineering", APPLIED_ENGINEERING)
-    MANUF("BSC/Alfadata", BSC_ALFADATA_3)
-    MANUF("Phoenix", PHOENIX)
-    MANUF("Advanced Storage Systems", ADVANCED_STORAGE_SYSTEMS)
-    MANUF("Impulse", IMPULSE)
-    MANUF("IVS", IVS)
-    MANUF("Vector", VECTOR_1)
-    MANUF("XPert ProDev", XPERT_PRODEV)
-    MANUF("Hydra Systems", HYDRA_SYSTEMS)
-    MANUF("Sunrize Industries", SUNRIZE_INDUSTRIES)
-    MANUF("Triceratops", TRICERATOPS)
-    MANUF("Applied Magic Inc.", APPLIED_MAGIC)
-    MANUF("GFX-Base", GFX_BASE)
-    MANUF("RocTec", ROCTEC)
-    MANUF("Kato", KATO)
-    MANUF("Atlantis", ATLANTIS)
-    MANUF("Protar", PROTAR)
-    MANUF("ACS", ACS)
-    MANUF("Software Results Enterprises", SOFTWARE_RESULTS_ENTERPRISES)
-    MANUF("Masoboshi", MASOBOSHI)
-    MANUF("Mainhattan-Data (A-Team)", MAINHATTAN_DATA)
-    MANUF("Village Tronic", VILLAGE_TRONIC)
-    MANUF("Utilities Unlimited", UTILITIES_UNLIMITED)
-    MANUF("Amitrix", AMITRIX)
-    MANUF("ArMax", ARMAX)
-    MANUF("ZEUS Electronic Development", ZEUS)
-    MANUF("NewTek", NEWTEK)
-    MANUF("M-Tech Germany", M_TECH_GERMANY)
-    MANUF("Great Valley Products", GREAT_VALLEY_PRODUCTS_4)
-    MANUF("Apollo", APOLLO_1)
-    MANUF("Ingenieurbro Helfrich", HELFRICH_2)
-    MANUF("MacroSystems USA", MACROSYSTEMS_USA)
-    MANUF("ElBox Computer", ELBOX_COMPUTER)
-    MANUF("Harms Professional", HARMS_PROFESSIONAL)
-    MANUF("Micronik", MICRONIK)
-    MANUF("Micronik", MICRONIK2)
-    MANUF("MegaMicro", MEGAMICRO)
-    MANUF("Ronin/Imtronics", IMTRONICS_2)
-    MANUF("Individual Computers", INDIVIDUAL_COMPUTERS)
-    MANUF("Kupke", KUPKE_3)
-    MANUF("ITH", ITH)
-    MANUF("VMC", VMC)
-    MANUF("Information", INFORMATION)
-    MANUF("Vortex", VORTEX)
-    MANUF("Expansion Systems", EXPANSION_SYSTEMS)
-    MANUF("ReadySoft", READYSOFT)
-    MANUF("Phase 5", PHASE5)
-    MANUF("DPS", DPS)
-    MANUF("Apollo", APOLLO_2)
-    MANUF("Apollo", APOLLO_3)
-    MANUF("Petsoff LP", PETSOFF_LP)
-    MANUF("Uwe Gerlach", UWE_GERLACH)
-    MANUF("ACT", ACT)
-    MANUF("MacroSystems Germany", MACROSYSTEMS_GERMANY)
-    MANUF("Combitec", COMBITEC)
-    MANUF("SKI Peripherals", SKI_PERIPHERALS)
-    MANUF("Reis-Ware", REIS_WARE_2)
-    MANUF("Cameron", CAMERON)
-    MANUF("Reis-Ware", REIS_WARE)
-    MANUF("Hacker Test Board", HACKER)	/* Unused */
-    MANUF("Phoenix", PHOENIX_2)
-    MANUF("Combitec", COMBITEC_2)
-END
-
-#define NUM_MANUF		(ARRAYSIZE(Manufacturers))
-#define NUM_GVP_PROD		(ARRAYSIZE(Ext_Prod_GVP))
-
-
-    /*
-     *  Zorro product classes
-     *
-     *  Make sure to keep these in sync with include/linux/zorro.h!
-     */
-
-static const char *classnames[] = {
-    NULL,				    /* ZORRO_CLASS_UNKNOWN */
-    "ArcNet Card",			    /* ZORRO_CLASS_ARCNET */
-    "Audio Board",			    /* ZORRO_CLASS_AUDIO */
-    "ISA Bus Bridge",			    /* ZORRO_CLASS_BRIDGE */
-    "DSP Board",			    /* ZORRO_CLASS_DSP */
-    "Ethernet Card",			    /* ZORRO_CLASS_ETHERNET */
-    "Ethernet Card and Parallel Ports",	    /* ZORRO_CLASS_ETHERNET_PARALLEL */
-    "Flash ROM",			    /* ZORRO_CLASS_FLASHROM */
-    "FPU and RAM Expansion",		    /* ZORRO_CLASS_FPU_RAM */
-    "Graphics Board",			    /* ZORRO_CLASS_GFX */
-    "Graphics Board (RAM)",		    /* ZORRO_CLASS_GFXRAM */
-    "HD Controller",			    /* ZORRO_CLASS_HD */
-    "HD Controller and RAM Expansion",	    /* ZORRO_CLASS_HD_RAM */
-    "IDE Interface",			    /* ZORRO_CLASS_IDE */
-    "IDE Interface and RAM Expansion",	    /* ZORRO_CLASS_IDE_RAM */
-    "IDE Interface and Floppy Controller",  /* ZORRO_CLASS_IDE_FLOPPY */
-    "ISDN Interface",			    /* ZORRO_CLASS_ISDN */
-    "Macintosh Emulator",		    /* ZORRO_CLASS_MACEMU */
-    "Miscellaneous Expansion Card",	    /* ZORRO_CLASS_MISC */
-    "Modem",				    /* ZORRO_CLASS_MODEM */
-    "Multi I/O",			    /* ZORRO_CLASS_MULTIIO */
-    "RAM Expansion",			    /* ZORRO_CLASS_RAM */
-    "Scanner Interface",		    /* ZORRO_CLASS_SCANNER */
-    "SCSI Host Adapter",		    /* ZORRO_CLASS_SCSI */
-    "SCSI Host Adapter and IDE Interface",  /* ZORRO_CLASS_SCSI_IDE */
-    "SCSI Host Adapter and RAM Expansion",  /* ZORRO_CLASS_SCSI_RAM */
-    "SCSI Host Adapter and Serial Card",    /* ZORRO_CLASS_SCSI_SERIAL */
-    "Multi Serial",			    /* ZORRO_CLASS_SERIAL */
-    "Drawing Tablet Interface",		    /* ZORRO_CLASS_TABLET */
-    "Accelerator",			    /* ZORRO_CLASS_TURBO */
-    "Accelerator and RAM Expansion",	    /* ZORRO_CLASS_TURBO_RAM */
-    "Accelerator and HD Controller",	    /* ZORRO_CLASS_TURBO_HD */
-    "Accelerator and IDE Interface",	    /* ZORRO_CLASS_TURBO_IDE */
-    "Accelerator and SCSI Host Adapter",    /* ZORRO_CLASS_TURBO_SCSI */
-    "Accelerator, SCSI Host Adapter and RAM Expansion",    /* ZORRO_CLASS_TURBO_SCSI */
-    "Video Board",			    /* ZORRO_CLASS_VIDEO */
-};
-
-static inline const char *get_class_name(enum Zorro_Classes class)
-{
-    if (class < ARRAYSIZE(classnames))
-	return(classnames[class]);
-    else
-	return("(**Illegal**)");
-}
-
-#endif /* CONFIG_ZORRO */
 
 
     /*
      *  Expansion Devices
      */
 
-u_int zorro_num_autocon;
+u_int zorro_num_autocon = 0;
 struct ConfigDev zorro_autocon[ZORRO_NUM_AUTO];
-static u32 BoardPartFlags[ZORRO_NUM_AUTO] = { 0, };
+static u32 zorro_autocon_parts[ZORRO_NUM_AUTO] = { 0, };
 
    
     /*
@@ -907,7 +39,7 @@
      *
      *  Index is used to specify the first board in the autocon list
      *  to be tested. It was inserted in order to solve the problem
-     *  with the GVP boards that uses the same product code, but
+     *  with the GVP boards that use the same product code, but
      *  it should help if there are other companies which use the same
      *  method as GVP. Drivers for boards which are not using this
      *  method do not need to think of this - just set index = 0.
@@ -923,33 +55,33 @@
 
 u_int zorro_find(zorro_id id, u_int part, u_int index)
 {
-    u_int manuf = ZORRO_MANUF(id);
-    u_int prod = ZORRO_PROD(id);
-    u_int epc = ZORRO_EPC(id);
+    u16 manuf = ZORRO_MANUF(id);
+    u8 prod = ZORRO_PROD(id);
+    u8 epc = ZORRO_EPC(id);
     u_int key;
     const struct ConfigDev *cd;
-    u_long addr;
+    u32 addr;
 
     if (!MACH_IS_AMIGA || !AMIGAHW_PRESENT(ZORRO))
-	return(0);
+	return 0;
 
     if (part > 31) {
 	printk("zorro_find: bad part %d\n", part);
-	return(0);
+	return 0;
     }
 
-    for (key = index + 1; key <= zorro_num_autocon; key++) {
+    for (key = index+1; key <= zorro_num_autocon; key++) {
 	cd = &zorro_autocon[key-1];
-	addr = (u_long)cd->cd_BoardAddr;
+	addr = (u32)cd->cd_BoardAddr;
 	if ((cd->cd_Rom.er_Manufacturer == manuf) &&
 	    (cd->cd_Rom.er_Product == prod) &&
-	    !(BoardPartFlags[key-1] & (1<<part)) &&
+	    !(zorro_autocon_parts[key-1] & (1<<part)) &&
 	    (manuf != ZORRO_MANUF(ZORRO_PROD_GVP_EPC_BASE) ||
-	     prod != ZORRO_PROD(ZORRO_PROD_GVP_EPC_BASE) ||
-	     (*(u_short *)ZTWO_VADDR(addr+0x8000) & GVP_PRODMASK) == epc))
-	    break;
+	     prod != ZORRO_PROD(ZORRO_PROD_GVP_EPC_BASE) || /* GVP quirk */
+	     (*(u16 *)ZTWO_VADDR(addr+0x8000) & GVP_PRODMASK) == epc))
+	    return key;
     }
-    return(key <= zorro_num_autocon ? key : 0);
+    return 0;
 }
 
 
@@ -959,14 +91,11 @@
 
 const struct ConfigDev *zorro_get_board(u_int key)
 {
-    const struct ConfigDev *cd = NULL;
-
-    if ((key < 1) || (key > zorro_num_autocon))
+    if ((key < 1) || (key > zorro_num_autocon)) {
 	printk("zorro_get_board: bad key %d\n", key);
-    else
-	cd = &zorro_autocon[key-1];
-
-    return(cd);
+	return NULL;
+    }
+    return &zorro_autocon[key-1];
 }
 
 
@@ -980,11 +109,11 @@
 	printk("zorro_config_board: bad key %d\n", key);
     else if (part > 31)
 	printk("zorro_config_board: bad part %d\n", part);
-    else if (BoardPartFlags[key-1] & (1<<part))
+    else if (zorro_autocon_parts[key-1] & (1<<part))
 	printk("zorro_config_board: key %d part %d is already configured\n",
 	       key, part);
     else
-	BoardPartFlags[key-1] |= 1<<part;
+	zorro_autocon_parts[key-1] |= 1<<part;
 }
 
 
@@ -1000,183 +129,13 @@
 	printk("zorro_unconfig_board: bad key %d\n", key);
     else if (part > 31)
 	printk("zorro_unconfig_board: bad part %d\n", part);
-    else if (!(BoardPartFlags[key-1] & (1<<part)))
+    else if (!(zorro_autocon_parts[key-1] & (1<<part)))
 	printk("zorro_config_board: key %d part %d is not yet configured\n",
 	       key, part);
     else
-	BoardPartFlags[key-1] &= ~(1<<part);
-}
-
-
-#ifdef CONFIG_ZORRO
-
-    /*
-     *  Identify an AutoConfig Expansion Device
-     *
-     *  If the board was configured by a Linux/m68k driver, an asterisk will
-     *  be printed before the board address (except for unknown and `Hacker
-     *  Test' boards).
-     */
-
-static int identify(u_int devnum, char *buf, int verbose)
-{
-    const struct ConfigDev *cd = &zorro_autocon[devnum];
-    u32 configured = BoardPartFlags[devnum];
-    u_int manuf = cd->cd_Rom.er_Manufacturer;
-    u_int prod = cd->cd_Rom.er_Product;
-    u_int class = ZORRO_CLASS_UNKNOWN;
-    u_int epc = 0;
-    const char *manufname = "Unknown";
-    const char *prodname = "Unknown";
-    const char *classname;
-    u_int i, j, k, len = 0;
-    u_long addr = (u_long)cd->cd_BoardAddr;
-    u_long size = cd->cd_BoardSize;
-    char mag;
-    int identified = 0, gvp = 0;
-
-    if (manuf != ZORRO_MANUF(ZORRO_PROD_GVP_EPC_BASE) ||
-	prod != ZORRO_PROD(ZORRO_PROD_GVP_EPC_BASE)) {
-	for (i = 0; i < NUM_MANUF; i++)
-	    if (Manufacturers[i].Manuf == manuf) {
-		manufname = Manufacturers[i].Name;
-		for (j = 0; j < Manufacturers[i].NumProd; j++)
-		    if (Manufacturers[i].Products[j].Prod == prod) {
-			prodname = Manufacturers[i].Products[j].Name;
-			class = Manufacturers[i].Products[j].Class;
-			identified = 1;
-			break;
-		    }
-	    }
-	/* Put workarounds for ID clashes here */
-	if (manuf == ZORRO_MANUF(ZORRO_PROD_HELFRICH_RAINBOW_III) &&
-	    prod == ZORRO_PROD(ZORRO_PROD_HELFRICH_RAINBOW_III))
-	    manufname = "Ingenieurbro Helfrich";
-    } else {
-	manufname = "Great Valley Products";
-	gvp = 1;
-	epc = *(u_short *)ZTWO_VADDR(addr+0x8000) & GVP_PRODMASK;
-	for (k = 0; k < NUM_GVP_PROD; k++)
-	    if (epc == Ext_Prod_GVP[k].EPC) {
-		prodname = Ext_Prod_GVP[k].Name;
-		class = Ext_Prod_GVP[k].Class;
-		identified = 1;
-		break;
-	    }
-    }
-    classname = get_class_name(class);
-    if (size & 0xfffff) {
-	size >>= 10;
-	mag = 'K';
-    } else {
-	size >>= 20;
-	mag = 'M';
-    }
-    if (verbose) {
-	const char *zorro;
-	int is_mem = cd->cd_Rom.er_Type & ERTF_MEMLIST;
-	switch (cd->cd_Rom.er_Type & ERT_TYPEMASK) {
-	    case ERT_ZORROII:
-		zorro = "Zorro II";
-		break;
-	    case ERT_ZORROIII:
-		zorro = "Zorro III";
-		break;
-	    default:
-		zorro = "Unknown Zorro";
-		break;
-	}
-	if (!prodname)
-	    prodname = "Unknown";
-	if (!classname)
-	    classname = "Unknown";
-	len = sprintf(buf, "  Device %d at 0x%08lx: ID=%04x:%02x", devnum,
-		      addr, manuf, prod);
-	if (gvp)
-	    len += sprintf(buf+len, ":%02x", epc);
-	len += sprintf(buf+len, ", %s, %ld%c", zorro, size, mag);
-	if (is_mem)
-	    len += sprintf(buf+len, ", System RAM");
-	else
-	    len += sprintf(buf+len, ", Configured=%08x", configured);
-	len += sprintf(buf+len, "\n"
-				"    Manufacturer: %s\n"
-				"    Product Name: %s\n"
-				"    Board Class : %s\n",
-				manufname, prodname, classname);
-    } else {
-	len = sprintf(buf, " %c%08lx: ", configured ? '*' : ' ', addr);
-	if (identified) {
-	    len += sprintf(buf+len, "%s", manufname);
-	    if (prodname)
-		len += sprintf(buf+len, " %s", prodname);
-	    if (classname)
-		len += sprintf(buf+len, " %s", classname);
-	} else if (manuf == ZORRO_MANUF_HACKER)
-	    len += sprintf(buf+len, "Hacker Test Board %02x", prod);
-	else if (gvp)
-	    len += sprintf(buf+len, "[%04x:%02x:%02x] made by %s", manuf, prod,
-			   epc, manufname);
-	else
-	    len += sprintf(buf+len, "[%04x:%02x] made by %s", manuf, prod,
-			   manufname);
-	len += sprintf(buf+len, " (%ld%c)\n", size, mag);
-	if (!identified && manuf != ZORRO_MANUF_HACKER)
-	    len += sprintf(buf+len, "    Please report this unknown device to "
-				    "zorro@linux-m68k.org\n");
-    }
-    return(len);
-}
-
-
-    /*
-     *  Identify all known AutoConfig Expansion Devices
-     */
-
-void zorro_identify(void)
-{
-    u_int i;
-    char tmp[256];
-
-    if (!AMIGAHW_PRESENT(ZORRO))
-	return;
-
-    printk("Probing AutoConfig expansion device(s):\n");
-    for (i = 0; i < zorro_num_autocon; i++) {
-	identify(i, tmp, 0);
-	printk(tmp);
-    }
-    if (!zorro_num_autocon)
-	printk("No AutoConfig expansion devices present.\n");
-}
-
-
-    /*
-     *  Get the list of all AutoConfig Expansion Devices
-     */
-
-int zorro_get_list(char *buffer)
-{
-    u_int i, len = 0, len2;
-    char tmp[256];
-
-    if (MACH_IS_AMIGA && AMIGAHW_PRESENT(ZORRO)) {
-	len = sprintf(buffer, "AutoConfig expansion devices:\n");
-	for (i = 0; i < zorro_num_autocon; i++) {
-	    len2 = identify(i, tmp, 1);
-	    if (len+len2 >= 4075) {
-		len += sprintf(buffer+len, "4K limit reached!\n");
-		break;
-	    }
-	    strcpy(buffer+len, tmp);
-	    len += len2;
-	}
-    }
-    return(len);
+	zorro_autocon_parts[key-1] &= ~(1<<part);
 }
 
-#endif /* CONFIG_ZORRO */
-
 
     /*
      *  Bitmask indicating portions of available Zorro II RAM that are unused
@@ -1194,9 +153,9 @@
 u32 zorro_unused_z2ram[4] = { 0, 0, 0, 0 };
 
 
-static void mark_region(u_long addr, u_long size, int flag)
+__initfunc(static void mark_region(u32 addr, u_int size, int flag))
 {
-    u_long start, end, chunk;
+    u32 start, end;
 
     if (flag) {
 	start = (addr+Z2RAM_CHUNKMASK) & ~Z2RAM_CHUNKMASK;
@@ -1210,11 +169,11 @@
     start = start < Z2RAM_START ? 0x00000000 : start-Z2RAM_START;
     end = end > Z2RAM_END ? Z2RAM_SIZE : end-Z2RAM_START;
     while (start < end) {
-	chunk = start>>Z2RAM_CHUNKSHIFT;
+	u32 chunk = start>>Z2RAM_CHUNKSHIFT;
 	if (flag)
-	    set_bit( chunk, zorro_unused_z2ram );
+	    set_bit(chunk, zorro_unused_z2ram);
 	else
-	    clear_bit( chunk, zorro_unused_z2ram );
+	    clear_bit(chunk, zorro_unused_z2ram);
 	start += Z2RAM_CHUNKSIZE;
     }
 }
@@ -1224,22 +183,47 @@
      *  Initialization
      */
 
-void zorro_init(void)
+__initfunc(void zorro_init(void))
 {
-    u_int i;
-    const struct ConfigDev *cd;
+    u_int i, j;
+    u32 disabled_z2mem = 0;
 
-    if (!AMIGAHW_PRESENT(ZORRO))
+    if (!MACH_IS_AMIGA || !AMIGAHW_PRESENT(ZORRO)) {
+	printk("Zorro: No Zorro bus detected\n");
 	return;
+    }
+
+    printk("Zorro: Probing AutoConfig expansion devices: %d device%s\n",
+	   zorro_num_autocon, zorro_num_autocon == 1 ? "" : "s");
 
     /* Mark all available Zorro II memory */
     for (i = 0; i < zorro_num_autocon; i++) {
-	cd = &zorro_autocon[i];
+	const struct ConfigDev *cd = &zorro_autocon[i];
 	if (cd->cd_Rom.er_Type & ERTF_MEMLIST)
-	    mark_region((u_long)cd->cd_BoardAddr, cd->cd_BoardSize, 1);
+	    mark_region((u32)cd->cd_BoardAddr, cd->cd_BoardSize, 1);
     }
 
     /* Unmark all used Zorro II memory */
     for (i = 0; i < m68k_num_memory; i++)
-	mark_region(m68k_memory[i].addr, m68k_memory[i].size, 0);
+	if (m68k_memory[i].addr < 16*1024*1024) {
+	    if (AMIGAHW_PRESENT(ZORRO3)) {
+		/* don't use Zorro II RAM as system memory on Zorro III */
+		/* capable machines */
+		if (i == 0) {
+		    /* don't cut off the branch we're sitting on */
+		    printk("Warning: kernel runs in Zorro II memory\n");
+		} else {
+		    disabled_z2mem += m68k_memory[i].size;
+		    m68k_num_memory--;
+		    for (j = i; j < m68k_num_memory; j++)
+			m68k_memory[j] = m68k_memory[j+1];
+		    i--;
+		    continue;
+		}
+	    }
+	    mark_region(m68k_memory[i].addr, m68k_memory[i].size, 0);
+	}
+    if (disabled_z2mem)
+	printk("%dK of Zorro II memory will not be used as system memory\n",
+	       disabled_z2mem>>10);
 }
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/drivers/zorro/zorrosyms.c m68k/drivers/zorro/zorrosyms.c
--- jes-2.1.105/drivers/zorro/zorrosyms.c	Thu Jan  1 01:00:00 1970
+++ m68k/drivers/zorro/zorrosyms.c	Mon Jun  8 01:21:02 1998
@@ -0,0 +1,22 @@
+/*
+ *	$Id: zorrosyms.c,v 1.1.2.1 1998/06/07 23:21:02 geert Exp $
+ *
+ *	Zorro Bus Services -- Exported Symbols
+ *
+ *	Copyright (C) 1998 Geert Uytterhoeven
+ */
+
+#include <linux/module.h>
+#include <linux/zorro.h>
+
+    /* Board configuration */
+
+EXPORT_SYMBOL(zorro_find);
+EXPORT_SYMBOL(zorro_get_board);
+EXPORT_SYMBOL(zorro_config_board);
+EXPORT_SYMBOL(zorro_unconfig_board);
+
+    /* Z2 memory */
+
+EXPORT_SYMBOL(zorro_unused_z2ram);
+
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/fs/proc/array.c m68k/fs/proc/array.c
--- jes-2.1.105/fs/proc/array.c	Mon Jun  8 20:46:59 1998
+++ m68k/fs/proc/array.c	Mon Jun  8 22:50:02 1998
@@ -1198,7 +1198,6 @@
 extern int get_rtc_status (char *);
 extern int get_locks_status (char *, char **, off_t, int);
 extern int get_swaparea_info (char *);
-extern int zorro_get_list(char *);
 extern int get_hardware_list(char *);
 extern int get_stram_list(char *);
 
@@ -1277,10 +1276,6 @@
 #endif
 		case PROC_LOCKS:
 			return get_locks_status(page, start, offset, length);
-#ifdef CONFIG_ZORRO
-		case PROC_ZORRO:
-			return zorro_get_list(page);
-#endif
 #ifdef CONFIG_PROC_HARDWARE
 		case PROC_HARDWARE:
 			return get_hardware_list(page);
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/fs/proc/root.c m68k/fs/proc/root.c
--- jes-2.1.105/fs/proc/root.c	Mon Jun  8 20:46:59 1998
+++ m68k/fs/proc/root.c	Mon Jun  8 22:50:05 1998
@@ -17,6 +17,9 @@
 #ifdef CONFIG_KMOD
 #include <linux/kmod.h>
 #endif
+#ifdef CONFIG_ZORRO
+#include <linux/zorro.h>
+#endif
 
 /*
  * Offset of the first process in the /proc root directory..
@@ -498,13 +501,6 @@
 	S_IFREG | S_IRUGO, 1, 0, 0,
 	0, &proc_array_inode_operations
 };
-#ifdef CONFIG_ZORRO
-static struct proc_dir_entry proc_root_zorro = {
-	PROC_ZORRO, 5, "zorro",
-	S_IFREG | S_IRUGO, 1, 0, 0,
-	0, &proc_array_inode_operations
-};
-#endif
 static struct proc_dir_entry proc_root_cpuinfo = {
 	PROC_CPUINFO, 7, "cpuinfo",
 	S_IFREG | S_IRUGO, 1, 0, 0,
@@ -639,9 +635,6 @@
 	proc_register(&proc_root, &proc_root_meminfo);
 	proc_register(&proc_root, &proc_root_kmsg);
 	proc_register(&proc_root, &proc_root_version);
-#ifdef CONFIG_ZORRO
-	proc_register(&proc_root, &proc_root_zorro);
-#endif
 	proc_register(&proc_root, &proc_root_cpuinfo);
 	proc_register(&proc_root, &proc_root_self);
 	proc_net = create_proc_entry("net", S_IFDIR, 0);
@@ -706,6 +699,13 @@
 #endif
 
 	proc_bus = create_proc_entry("bus", S_IFDIR, 0);
+
+#ifdef CONFIG_PCI
+	pci_proc_init();
+#endif
+#ifdef CONFIG_ZORRO
+	zorro_proc_init();
+#endif
 }
 
 /*
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/include/asm-m68k/ide.h m68k/include/asm-m68k/ide.h
--- jes-2.1.105/include/asm-m68k/ide.h	Mon Jun  8 20:47:05 1998
+++ m68k/include/asm-m68k/ide.h	Mon Jun  8 23:27:43 1998
@@ -56,6 +56,7 @@
 	return 0;
 }
 
+#ifndef CONFIG_APUS
 /*
  *  Can we do this in a generic manner??
  */
@@ -63,6 +64,7 @@
 {
     printk("ide_init_hwif_ports: must not be called\n");
 }
+#endif
 
 typedef union {
 	unsigned all			: 8;	/* all of the bits together */
@@ -134,6 +136,7 @@
 #undef HD_DATA
 #define HD_DATA NULL
 
+#ifndef CONFIG_APUS
 #define insl(data_reg, buffer, wcount) insw(data_reg, buffer, (wcount)<<1)
 #define outsl(data_reg, buffer, wcount) outsw(data_reg, buffer, (wcount)<<1)
 
@@ -214,6 +217,7 @@
 		: "a" (_port), "0" (_buf),		\
 		  "1" (_tmp));				\
 })
+#endif /* !CONFIG_APUS */
 
 #ifdef CONFIG_ATARI
 #define insl_swapw(data_reg, buffer, wcount) \
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/include/asm-m68k/irq.h m68k/include/asm-m68k/irq.h
--- jes-2.1.105/include/asm-m68k/irq.h	Mon May  4 20:13:57 1998
+++ m68k/include/asm-m68k/irq.h	Mon Jun  1 10:51:30 1998
@@ -67,8 +67,11 @@
  *                                                      01/11/97 - Jes
  */
 
+#ifndef CONFIG_APUS
+/* Allow this file to be included from asm-ppc/irc.h without conflicts. */
 extern void (*enable_irq)(unsigned int);
 extern void (*disable_irq)(unsigned int);
+#endif
 
 extern int sys_request_irq(unsigned int, 
 	void (*)(int, void *, struct pt_regs *), 
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/include/linux/proc_fs.h m68k/include/linux/proc_fs.h
--- jes-2.1.105/include/linux/proc_fs.h	Mon Jun  8 20:47:10 1998
+++ m68k/include/linux/proc_fs.h	Mon Jun  8 23:26:40 1998
@@ -44,7 +44,6 @@
 	PROC_MD,
 	PROC_RTC,
 	PROC_LOCKS,
-	PROC_ZORRO,
 	PROC_HARDWARE,
 	PROC_SLABINFO,
 	PROC_PARPORT,
@@ -209,16 +208,18 @@
 enum bus_directory_inos {
 	PROC_BUS_PCI = PROC_MCA_LAST,
 	PROC_BUS_PCI_DEVICES,
+	PROC_BUS_ZORRO,
+	PROC_BUS_ZORRO_DEVICES,
 	PROC_BUS_LAST
 };
 
 enum fs_directory_inos {
-	PROC_FS_CODA = PROC_MCA_LAST,
+	PROC_FS_CODA = PROC_BUS_LAST,
 	PROC_FS_LAST
 };
 
 enum fs_coda_directory_inos {
-	PROC_VFS_STATS = PROC_MCA_LAST,
+	PROC_VFS_STATS = PROC_FS_LAST,
 	PROC_UPCALL_STATS,
 	PROC_PERMISSION_STATS,
 	PROC_CACHE_INV_STATS,
diff -u --recursive --exclude-from=/home/geert/diff-excludes-linux --new-file jes-2.1.105/include/linux/zorro.h m68k/include/linux/zorro.h
--- jes-2.1.105/include/linux/zorro.h	Mon Jun  8 20:47:11 1998
+++ m68k/include/linux/zorro.h	Mon Jun  8 23:19:10 1998
@@ -1,12 +1,7 @@
 /*
- *  linux/zorro.h -- Amiga AutoConfig (Zorro) Expansion Device Definitions
+ *  linux/zorro.h -- Amiga AutoConfig (Zorro) Bus Definitions
  *
- *  Copyright (C) 1995 Geert Uytterhoeven
- *
- *  Please update arch/m68k/amiga/zorro.c if you make changes here!
- *
- *  Many IDs were obtained from ExpName/Identify ((C) Richard Krber)
- *  and by looking at the NetBSD-Amiga kernel sources
+ *  Copyright (C) 1995-1998 Geert Uytterhoeven
  *
  *  This file is subject to the terms and conditions of the GNU General Public
  *  License.  See the file COPYING in the main directory of this archive
@@ -19,53 +14,7 @@
 #ifndef __ASSEMBLY__
 
     /*
-     *  Zorro Product Classes
-     *
-     *  Make sure to keep these in sync with arch/m68k/amiga/zorro.c!
-     */
-
-enum Zorro_Classes {
-    ZORRO_CLASS_UNKNOWN = 0x00,
-    ZORRO_CLASS_ARCNET,
-    ZORRO_CLASS_AUDIO,
-    ZORRO_CLASS_BRIDGE,
-    ZORRO_CLASS_DSP,
-    ZORRO_CLASS_ETHERNET,
-    ZORRO_CLASS_ETHERNET_PARALLEL,
-    ZORRO_CLASS_FLASHROM,
-    ZORRO_CLASS_FPU_RAM,
-    ZORRO_CLASS_GFX,
-    ZORRO_CLASS_GFXRAM,
-    ZORRO_CLASS_HD,
-    ZORRO_CLASS_HD_RAM,
-    ZORRO_CLASS_IDE,
-    ZORRO_CLASS_IDE_RAM,
-    ZORRO_CLASS_IDE_FLOPPY,
-    ZORRO_CLASS_ISDN,
-    ZORRO_CLASS_MACEMU,
-    ZORRO_CLASS_MISC,
-    ZORRO_CLASS_MODEM,
-    ZORRO_CLASS_MULTIIO,
-    ZORRO_CLASS_RAM,
-    ZORRO_CLASS_SCANNER,
-    ZORRO_CLASS_SCSI,
-    ZORRO_CLASS_SCSI_IDE,
-    ZORRO_CLASS_SCSI_RAM,
-    ZORRO_CLASS_SCSI_SERIAL,
-    ZORRO_CLASS_SERIAL,
-    ZORRO_CLASS_TABLET,
-    ZORRO_CLASS_TURBO,
-    ZORRO_CLASS_TURBO_RAM,
-    ZORRO_CLASS_TURBO_HD,
-    ZORRO_CLASS_TURBO_IDE,
-    ZORRO_CLASS_TURBO_SCSI,
-    ZORRO_CLASS_TURBO_SCSI_RAM,
-    ZORRO_CLASS_VIDEO,
-};
-
-
-    /*
      *  Known Zorro Boards
      *
      *  Each Zorro board has a 32-bit ID of the form
      *
@@ -623,7 +570,6 @@
 
     /*
      *  Test and illegal Manufacturer IDs.
-     *  These do NOT appear in arch/m68k/amiga/zorro.c!
      */
 
 #define ZORRO_MANUF_HACKER					0x07DB
@@ -659,24 +605,24 @@
 struct Node {
     struct  Node *ln_Succ;	/* Pointer to next (successor) */
     struct  Node *ln_Pred;	/* Pointer to previous (predecessor) */
-    u_char  ln_Type;
-    char    ln_Pri;		/* Priority, for sorting */
-    char    *ln_Name;		/* ID string, null terminated */
+    __u8    ln_Type;
+    __s8    ln_Pri;		/* Priority, for sorting */
+    __s8    *ln_Name;		/* ID string, null terminated */
 };
 
 struct ExpansionRom {
     /* -First 16 bytes of the expansion ROM */
-    u_char	er_Type;	/* Board type, size and flags */
-    u_char	er_Product;	/* Product number, assigned by manufacturer */
-    u_char	er_Flags;	/* Flags */
-    u_char	er_Reserved03;	/* Must be zero ($ff inverted) */
-    u_short	er_Manufacturer;/* Unique ID,ASSIGNED BY COMMODORE-AMIGA! */
-    u_long	er_SerialNumber;/* Available for use by manufacturer */
-    u_short	er_InitDiagVec;	/* Offset to optional "DiagArea" structure */
-    u_char	er_Reserved0c;
-    u_char	er_Reserved0d;
-    u_char	er_Reserved0e;
-    u_char	er_Reserved0f;
+    __u8  er_Type;		/* Board type, size and flags */
+    __u8  er_Product;		/* Product number, assigned by manufacturer */
+    __u8  er_Flags;		/* Flags */
+    __u8  er_Reserved03;	/* Must be zero ($ff inverted) */
+    __u16 er_Manufacturer;	/* Unique ID, ASSIGNED BY COMMODORE-AMIGA! */
+    __u32 er_SerialNumber;	/* Available for use by manufacturer */
+    __u16 er_InitDiagVec;	/* Offset to optional "DiagArea" structure */
+    __u8  er_Reserved0c;
+    __u8  er_Reserved0d;
+    __u8  er_Reserved0e;
+    __u8  er_Reserved0f;
 };
 
 /* er_Type board type bits */
@@ -690,16 +636,16 @@
 
 struct ConfigDev {
     struct Node 	cd_Node;
-    u_char		cd_Flags;	/* (read/write) */
-    u_char		cd_Pad; 	/* reserved */
+    __u8  		cd_Flags;	/* (read/write) */
+    __u8  		cd_Pad; 	/* reserved */
     struct ExpansionRom cd_Rom; 	/* copy of board's expansion ROM */
     void		*cd_BoardAddr;	/* where in memory the board was placed */
-    u_long		cd_BoardSize;	/* size of board in bytes */
-    u_short		cd_SlotAddr;	/* which slot number (PRIVATE) */
-    u_short		cd_SlotSize;	/* number of slots (PRIVATE) */
+    __u32 		cd_BoardSize;	/* size of board in bytes */
+    __u16  		cd_SlotAddr;	/* which slot number (PRIVATE) */
+    __u16  		cd_SlotSize;	/* number of slots (PRIVATE) */
     void		*cd_Driver;	/* pointer to node of driver */
     struct ConfigDev	*cd_NextCD;	/* linked list of drivers to config */
-    u_long		cd_Unused[4];	/* for whatever the driver wants */
+    __u32 		cd_Unused[4];	/* for whatever the driver wants */
 };
 
 #else /* __ASSEMBLY__ */
@@ -745,7 +691,7 @@
 
 #ifdef __KERNEL__
 
-extern unsigned int zorro_num_autocon;		/* # of autoconfig devices found */
+extern unsigned int zorro_num_autocon;	/* # of autoconfig devices found */
 extern struct ConfigDev zorro_autocon[ZORRO_NUM_AUTO];
 
 
@@ -753,6 +699,9 @@
      *  Zorro Functions
      */
 
+extern void zorro_init(void);
+extern void zorro_proc_init(void);
+
 extern unsigned int zorro_find(zorro_id id, unsigned int part, unsigned int index);
 extern const struct ConfigDev *zorro_get_board(unsigned int key);
 extern void zorro_config_board(unsigned int key, unsigned int part);
@@ -768,7 +717,7 @@
      *  the corresponding bits.
      */
 
-extern u32 zorro_unused_z2ram[4];
+extern __u32 zorro_unused_z2ram[4];
 
 #define Z2RAM_START		(0x00200000)
 #define Z2RAM_END		(0x00a00000)
@@ -777,13 +726,6 @@
 #define Z2RAM_CHUNKMASK		(0x0000ffff)
 #define Z2RAM_CHUNKSHIFT	(16)
 
-
-    /*
-     *  Verbose Board Identification
-     */
-
-extern void zorro_identify(void);
-extern int zorro_get_list(char *buffer);
 
 #endif /* !__ASSEMBLY__ */
 #endif /* __KERNEL__ */

Greetings,

						Geert

--
Geert Uytterhoeven                     Geert.Uytterhoeven@cs.kuleuven.ac.be
Wavelets, Linux/{m68k~Amiga,PPC~CHRP}  http://www.cs.kuleuven.ac.be/~geert/
Department of Computer Science -- Katholieke Universiteit Leuven -- Belgium

